DATA DATA0;     /* for MODEL [I] */
INFILE 'G:\BOX-ANN\CHILD.dat'; 
INPUT k y1 x11 x12@@;  
t=_N_; 
y=(y1-90)/(120-90); x1=(x11-1)/(6-1); x2=(x12-20)/(30-20);
                    
eta=7.05;               
h=1;     /* change the seed of random numbers */                     
/* UNIFORM RANDOM NUMBERS for weights and biases */
/* FIRST LINEAR TRANSFORMATION */
IF UNIFORM(1+h)<=0.5 THEN w1_11=-UNIFORM(1+h)/10; ELSE w1_11=UNIFORM(1+h)/10;
IF UNIFORM(2+h)<=0.5 THEN w1_21=-UNIFORM(2+h)/10; ELSE w1_21=UNIFORM(2+h)/10;
IF UNIFORM(3+h)<=0.5 THEN w1_12=-UNIFORM(3+h)/10; ELSE w1_12=UNIFORM(3+h)/10;
IF UNIFORM(4+h)<=0.5 THEN w1_22=-UNIFORM(4+h)/10; ELSE w1_22=UNIFORM(4+h)/10;
IF UNIFORM(5+h)<=0.5 THEN w1_13=-UNIFORM(5+h)/10; ELSE w1_13=UNIFORM(5+h)/10;
IF UNIFORM(6+h)<=0.5 THEN w1_23=-UNIFORM(6+h)/10; ELSE w1_23=UNIFORM(6+h)/10;
IF UNIFORM(7+h)<=0.5 THEN w1_14=-UNIFORM(7+h)/10; ELSE w1_14=UNIFORM(7+h)/10;
IF UNIFORM(8+h)<=0.5 THEN w1_24=-UNIFORM(8+h)/10; ELSE w1_24=UNIFORM(8+h)/10;
z1=w1_11*x1+w1_21*x2; z2=w1_12*x1+w1_22*x2;   
z3=w1_13*x1+w1_23*x2; z4=w1_14*x1+w1_24*x2;   

/* FIRST ACTIVITY FUNCTION */ 

IF UNIFORM(9+h)<=0.5 THEN b1=-UNIFORM(9+h)/10; ELSE b1=UNIFORM(9+h)/10;
IF UNIFORM(10+h)<=0.5 THEN b2=-UNIFORM(10+h)/10; ELSE b2=UNIFORM(10+h)/10;
IF UNIFORM(11+h)<=0.5 THEN b3=-UNIFORM(11+h)/10; ELSE b3=UNIFORM(11+h)/10;
IF UNIFORM(12+h)<=0.5 THEN b4=-UNIFORM(12+h)/10; ELSE b4=UNIFORM(12+h)/10;
s1=1/(1+exp(-(z1+b1))); s2=1/(1+exp(-(z2+b2)));
s3=1/(1+exp(-(z3+b3))); s4=1/(1+exp(-(z4+b4)));                                          

/* SECOND LINEAR TRANSFORMATION */ 
IF UNIFORM(14+h)<=0.5 THEN w2_11=-UNIFORM(14+h)/10; ELSE w2_11=UNIFORM(14+h)/10;
IF UNIFORM(15+h)<=0.5 THEN w2_21=-UNIFORM(15+h)/10; ELSE w2_21=UNIFORM(15+h)/10;
IF UNIFORM(16+h)<=0.5 THEN w2_31=-UNIFORM(16+h)/10; ELSE w2_31=UNIFORM(16+h)/10;
IF UNIFORM(17+h)<=0.5 THEN w2_41=-UNIFORM(17+h)/10; ELSE w2_41=UNIFORM(17+h)/10;
z5=w2_11*s1+w2_21*s2+w2_31*s3+w2_41*s4;


/* FIRST ESTIMATED VALUE */ 
IF UNIFORM(13+h)<=0.5 THEN b5=-UNIFORM(13+h)/10; ELSE b5=UNIFORM(13+h)/10; 
s5=1/(1+exp(-(z5+b5)));
y_hat=s5;

/* BACKPROPAGATION step 1(right hand size) */

/* PARTIAL DERIVATIVES OF LOSS FUNCTION w/t WEIGHT pp.7-8 */
pLpw1_11=-2*(y-y_hat)*(w2_11*s5*(1-s5))*(x1*s1*(1-s1));
pLpw1_21=-2*(y-y_hat)*(w2_21*s5*(1-s5))*(x2*s1*(1-s1));
pLpw1_12=-2*(y-y_hat)*(w2_31*s5*(1-s5))*(x1*s2*(1-s2));
pLpw1_22=-2*(y-y_hat)*(w2_41*s5*(1-s5))*(x2*s2*(1-s2));
pLpw1_13=-2*(y-y_hat)*(w2_11*s5*(1-s5))*(x1*s3*(1-s3));
pLpw1_23=-2*(y-y_hat)*(w2_21*s5*(1-s5))*(x2*s3*(1-s3));
pLpw1_14=-2*(y-y_hat)*(w2_31*s5*(1-s5))*(x1*s4*(1-s4));
pLpw1_24=-2*(y-y_hat)*(w2_41*s5*(1-s5))*(x2*s4*(1-s4));

pLpw2_11=-2*(y-y_hat)*s5*(1-s5)*s1;
pLpw2_21=-2*(y-y_hat)*s5*(1-s5)*s2;
pLpw2_31=-2*(y-y_hat)*s5*(1-s5)*s3;
pLpw2_41=-2*(y-y_hat)*s5*(1-s5)*s4;

/* new wights ws_11 etc */
w2s_11=w2_11-eta*pLpw2_11;
w2s_21=w2_21-eta*pLpw2_21; 
w2s_31=w2_31-eta*pLpw2_31;
w2s_41=w2_41-eta*pLpw2_41;

/* FIRST STEP UPDATED WEIGHTS */
pLpw2s_11=pLpw2_11-eta*pLpw2_11; 
pLpw2s_21=pLpw2_21-eta*pLpw2_21;
pLpw2s_31=pLpw2_31-eta*pLpw2_31; 
pLpw2s_41=pLpw2_41-eta*pLpw2_41;

/* BACKPROPAGATION step 2(left hand size) */ 
pLpw1s_11=-2*(y-y_hat)*(w2s_11*s5*(1-s5))*(x1*s1*(1-s1)); 
pLpw1s_21=-2*(y-y_hat)*(w2s_21*s5*(1-s5))*(x2*s1*(1-s1));
pLpw1s_12=-2*(y-y_hat)*(w2s_31*s5*(1-s5))*(x1*s2*(1-s2));
pLpw1s_22=-2*(y-y_hat)*(w2s_41*s5*(1-s5))*(x2*s2*(1-s2));
pLpw1s_13=-2*(y-y_hat)*(w2s_11*s5*(1-s5))*(x1*s3*(1-s3));
pLpw1s_23=-2*(y-y_hat)*(w2s_21*s5*(1-s5))*(x2*s3*(1-s3));
pLpw1s_14=-2*(y-y_hat)*(w2s_31*s5*(1-s5))*(x1*s4*(1-s4));
pLpw1s_24=-2*(y-y_hat)*(w2s_41*s5*(1-s5))*(x2*s4*(1-s4));

/* SECOND STEP UPDATED WEIGHTS 8888 */ 
/* 
w1s_11=w1s_11-eta*pLpw1s_11; w1s_21=w1s_21-eta*pLpw1s_21; 
w1s_12=w1s_12-eta*pLpw1s_12; w1s_22=w1s_22-eta*pLpw1s_22;
w1s_13=w1s_13-eta*pLpw1s_13; w1s_23=w1s_23-eta*pLpw1s_23;
w1s_14=w1s_14-eta*pLpw1s_14; w1s_24=w1s_24-eta*pLpw1s_24; */

w1s_11=w1_11-eta*pLpw1s_11; w1s_21=w1_21-eta*pLpw1s_21;
w1s_12=w1_12-eta*pLpw1s_12; w1s_22=w1_22-eta*pLpw1s_22;
w1s_13=w1_13-eta*pLpw1s_13; w1s_23=w1_23-eta*pLpw1s_23;
w1s_14=w1_14-eta*pLpw1s_14; w1s_24=w1_24-eta*pLpw1s_24;

/* CHECK step HERE */
zs_1=w1s_11*x1+w1s_21*x2;
zs_2=w1s_12*x1+w1s_22*x2;
zs_3=w1s_13*x1+w1s_23*x2;
zs_4=w1s_14*x1+w1s_24*x2;

eta=7.02; 
h=2;
 
IF UNIFORM(23+h)<=0.5 THEN b11=-UNIFORM(23+h)/10; ELSE b11=UNIFORM(23+h)/10;
IF UNIFORM(24+h)<=0.5 THEN b12=-UNIFORM(24+h)/10; ELSE b12=UNIFORM(24+h)/10;
IF UNIFORM(25+h)<=0.5 THEN b13=-UNIFORM(25+h)/10; ELSE b13=UNIFORM(25+h)/10;
IF UNIFORM(26+h)<=0.5 THEN b14=-UNIFORM(26+h)/10; ELSE b14=UNIFORM(26+h)/10; 
ss_1=1/(1+exp(-(zs_1+b11)));  
ss_2=1/(1+exp(-(zs_2+b12)));
ss_3=1/(1+exp(-(zs_3+b13)));
ss_4=1/(1+exp(-(zs_4+b14)));

zs_5=w2s_11*ss_1+w2s_21*ss_2+w2s_31*ss_3+w2s_41*ss_4;

IF UNIFORM(27+h)<=0.5 THEN b15=-UNIFORM(27+h)/10; ELSE b15=UNIFORM(27+h)/10; 
ss5=1/(1+exp(-(zs_5+b15)));  
y1_hat=ss5;    

By1_hat=y1_hat*(120-90)+90;    /* ORIGINAL UNIT FOR y_hat=s5; */

/* ******************************************************* */
/*            computation of y0_hat                        */
/* ******************************************************* */
x10=0.8; x20=0.9;  
 
z10=w1s_11*x10+w1s_21*x20; z20=w1s_12*x10+w1s_22*x20;   
z30=w1s_13*x10+w1s_23*x20; z40=w1s_14*x10+w1s_24*x20;

IF UNIFORM(18+h)<=0.5 THEN b6=-UNIFORM(18+h)/10; ELSE b6=UNIFORM(18+h)/10; 
IF UNIFORM(19+h)<=0.5 THEN b7=-UNIFORM(19+h)/10; ELSE b7=UNIFORM(19+h)/10;
IF UNIFORM(20+h)<=0.5 THEN b8=-UNIFORM(20+h)/10; ELSE b8=UNIFORM(20+h)/10;
IF UNIFORM(21+h)<=0.5 THEN b9=-UNIFORM(21+h)/10; ELSE b9=UNIFORM(21+h)/10;
IF UNIFORM(22+h)<=0.5 THEN b10=-UNIFORM(22+h)/10; ELSE b10=UNIFORM(22+h)/10; 

s10=1/(1+exp(-(z10+b6))); s20=1/(1+exp(-(z20+b7)));
s30=1/(1+exp(-(z30+b8))); s40=1/(1+exp(-(z40+b9)));                                          

z50=w2_11*s10+w2_21*s20+w2_31*s30+w2_41*s40;
s50=1/(1+exp(-(z50+b10)));
y0_hat=s50; 

By0_hat=y0_hat*(120-90)+90; 

/* *********************************************** */

/* PARTIAL DERIVATIVES OF LOSS FUNCTION w/t WEIGHT */
pLpw1_11=-2*(y-y1_hat)*(w2_11*s5*(1-s5))*(x1*s1*(1-s1));
pLpw1_21=-2*(y-y1_hat)*(w2_21*s5*(1-s5))*(x2*s1*(1-s1));
pLpw1_12=-2*(y-y1_hat)*(w2_31*s5*(1-s5))*(x1*s2*(1-s2));
pLpw1_22=-2*(y-y1_hat)*(w2_41*s5*(1-s5))*(x2*s2*(1-s2));
pLpw1_13=-2*(y-y1_hat)*(w2_11*s5*(1-s5))*(x1*s3*(1-s3));
pLpw1_23=-2*(y-y1_hat)*(w2_21*s5*(1-s5))*(x2*s3*(1-s3));
pLpw1_14=-2*(y-y1_hat)*(w2_31*s5*(1-s5))*(x1*s4*(1-s4));
pLpw1_24=-2*(y-y1_hat)*(w2_41*s5*(1-s5))*(x2*s4*(1-s4));

/* BACKPROPAGATION step 1(right hand size) */

pLpw2_11=-2*(y-y1_hat)*s5*(1-s5)*s1;
pLpw2_21=-2*(y-y1_hat)*s5*(1-s5)*s2;
pLpw2_31=-2*(y-y1_hat)*s5*(1-s5)*s3;
pLpw2_41=-2*(y-y1_hat)*s5*(1-s5)*s4;

/* new wights ws_11 etc  */
w2s_11=w2_11-eta*pLpw2_11;
w2s_21=w2_21-eta*pLpw2_21; 
w2s_31=w2_31-eta*pLpw2_31;
w2s_41=w2_41-eta*pLpw2_41;

/* FIRST STEP UPDATED WEIGHTS */
pLpw2s_11=pLpw2_11-eta*pLpw2_11; 
pLpw2s_21=pLpw2_21-eta*pLpw2_21;
pLpw2s_31=pLpw2_31-eta*pLpw2_31; 
pLpw2s_41=pLpw2_41-eta*pLpw2_41;

/* BACKPROPAGATION step 2(left hand size) */
pLpw1s_11=-2*(y-y1_hat)*(w2_11*s5*(1-s5))*(x1*s1*(1-s1));
pLpw1s_21=-2*(y-y1_hat)*(w2_21*s5*(1-s5))*(x2*s1*(1-s1));
pLpw1s_12=-2*(y-y1_hat)*(w2_31*s5*(1-s5))*(x1*s2*(1-s2));
pLpw1s_22=-2*(y-y1_hat)*(w2_41*s5*(1-s5))*(x2*s2*(1-s2));
pLpw1s_13=-2*(y-y1_hat)*(w2_11*s5*(1-s5))*(x1*s3*(1-s3));
pLpw1s_23=-2*(y-y1_hat)*(w2_21*s5*(1-s5))*(x2*s3*(1-s3));
pLpw1s_14=-2*(y-y1_hat)*(w2_31*s5*(1-s5))*(x1*s4*(1-s4));
pLpw1s_24=-2*(y-y1_hat)*(w2_41*s5*(1-s5))*(x2*s4*(1-s4));

/* SECOND STEP UPDATED WEIGHTS */
w1s_11=w1_11-eta*pLpw1s_11; w1s_21=w1_21-eta*pLpw1s_21;
w1s_12=w1_12-eta*pLpw1s_12; w1s_22=w1_22-eta*pLpw1s_22;
w1s_13=w1_13-eta*pLpw1s_13; w1s_23=w1_23-eta*pLpw1s_23;
w1s_14=w1_14-eta*pLpw1s_14; w1s_24=w1_24-eta*pLpw1s_24;

/* CHECK step HERE p.16 */
zs_1=w1s_11*x1+w1s_21*x2;
zs_2=w1s_12*x1+w1s_22*x2;
zs_3=w1s_13*x1+w1s_23*x2;
zs_4=w1s_14*x1+w1s_24*x2;

ss_1=1/(1+exp(-(zs_1+b11)));  
ss_2=1/(1+exp(-(zs_2+b12)));
ss_3=1/(1+exp(-(zs_3+b13)));
ss_4=1/(1+exp(-(zs_4+b14)));

zs_5=w2s_11*ss_1+w2s_21*ss_2+w2s_31*ss_3+w2s_41*ss_4;

ss5=1/(1+exp(-(zs_5+b15)));  
y2_hat=ss5;    
By2_hat=y2_hat*(120-90)+90;

/*  NEW ERROR */
ERROR=y-y_hat;
BERROR=(y-y_hat)*(120-90)+90;
ERROR_sq=(y-y_hat)**2;
BERROR_sq=ERROR_sq*(120-90)+90;

ERROR1=y-y1_hat;
BERROR1=(y-y1_hat)*(120-90)+90;
ERROR1_sq=(y-y1_hat)**2;
BERROR1_sq=ERROR1_sq*(120-90)+90;

ERROR2=y-y2_hat;
BERROR2=(y-y2_hat)*(120-90)+90;
ERROR2_sq=(y-y2_hat)**2;
BERROR2_sq=ERROR2_sq*(120-90)+90;

SSR1=(y1-By1_hat)**2;
SSR2=(y1-By2_hat)**2;
n=20; 

MSE_ANN1=SSR1/n;
MSE_ANN2=SSR2/n;

PROC PRINT DATA=DATA0; VAR s10 s20 s30 s40 s50 y0_hat By0_hat;
RUN;

PROC MEANS SUM; VAR y1_hat By1_hat y0_hat By0_hat SSR1 SSR2 MSE_ANN1 MSE_ANN2;
RUN;
 
PROC PRINT DATA=DATA0; VAR y y_hat y1_hat y2_hat;
RUN;

PROC MEANS DATA=DATA0; VAR y y_hat y1_hat y2_hat;
RUN; 

PROC MEANS DATA=DATA0; VAR ERROR ERROR1 ERROR2 BERROR BERROR1 BERROR2;
RUN;

PROC MEANS DATA=DATA0; VAR ERROR_sq ERROR1_sq ERROR2_sq BERROR_sq BERROR1_sq BERROR2_sq;
RUN;

SYMBOL1 v=dot cv=black l=1 color=red;
SYMBOL2 v=circle cv=black i=spline ci=black; 
SYMBOL3 v=star cv=black i=line ci=black; 
SYMBOL4 v=none cv=black i=join ci=black; 
SYMBOL5 v=none cv=black i=line ci=black; 
SYMBOL6 v=none cv=black i=spline ci=black;

PROC GPLOT DATA=DATA0;  
PLOT BERROR_sq*x11=1/OVERLAY grid frame;  
RUN;

PROC GPLOT DATA=DATA0;  
PLOT BERROR_sq*x11=1/OVERLAY grid frame;  
RUN;

PROC GPLOT DATA=DATA0;  
PLOT ERROR*x11=1/OVERLAY grid frame;  
RUN;

PROC GPLOT DATA=DATA0;  
PLOT ERROR_sq*x11=1/OVERLAY grid frame;  
RUN;

PROC GPLOT DATA=DATA0;  
PLOT BERROR*x11=1/OVERLAY grid frame;  
RUN;

PROC REG DATA=DATA0;                /* orignal data by_hat */
MODEL y1=x11 x12/p clb vif alpha=0.05;
OUTPUT OUT=new PREDICTED=pred RESIDUAL=resid;
RUN;

PROC REG DATA=DATA0;                /* orignal data by_hat */
MODEL y=x1 x2/p clb vif alpha=0.05;
OUTPUT OUT=new1 PREDICTED=pred1 RESIDUAL=resid1;
RUN;

