DATA data1;
DO t=-5000 TO 5000;
k=t/1000;
nu=k;
pi=3.14;
M=5;
a=0.25;

Wkrect=1;
Wnurect=(1/(2*pi))*(sin((M+0.5)*nu)/sin(nu/2));

Wkbart=1-(abs(k)/M);
Wnubart=(1/(2*pi*M))*(sin((nu*M)/2)/sin(nu/2))**2;

Wkparz1=1-6*(k/M)**2+6*(abs(k)/M)**3;
Wkparz2=2*(1-abs(k)/M)**3;
Wkparz3=0;

WkBT=1-(2*a)+((2*a)*cos((pi*k)/M));
WnuBT=a*((1/(2*pi))*(sin((M+0.5)*(nu-pi/M))/sin((nu-pi/M)/2)))
     +(1-2*a)*((1/(2*pi))*(sin((M+0.5)*nu)/sin(nu/2)))
     +a*((1/(2*pi))*(sin((M+0.5)*(nu+pi/M))/sin((nu+pi/M)/2)));

IF abs(k)<=M/2 THEN Wkparz=Wkparz1; 
IF M/2<abs(k)<=M THEN Wkparz=Wkparz2;
IF M<abs(k) THEN Wkparz=Wkparz3;

Wnuparz=(3/(8*pi*M**3))*(sin((nu*M)/4)/(0.5*sin(nu/2)))**4;

OUTPUT data1;
END;
RUN;
 
/*
PROC PRINT;
VAR nu Wk;
RUN; */

SYMBOL1 v=dot cv=black i=line ci=black;
SYMBOL2 v=circle cv=black i=spline ci=black; 
SYMBOL3 v=none cv=black i=join ci=black; 
SYMBOL4 v=none cv=black i=line ci=black; 
SYMBOL5 v=none cv=black i=spline ci=black; 

PROC GPLOT; 
PLOT Wkrect*k=3/GRID FRAME HREF=0 VAXIS=0  TO 1.5 BY 0.2 HAXIS=-10 TO 10 BY 5;
symbol c=black v=line i=join;
RUN;
PROC GPLOT; 
PLOT Wnurect*nu=3/GRID FRAME HREF=0 VREF=0 VAXIS=-0.5  TO 2 BY 0.2 HAXIS=-6 TO 6 BY 1;
symbol c=black v=line i=join;
RUN;


PROC GPLOT; 
PLOT Wkbart*k=3/GRID FRAME HREF=0 VAXIS=0  TO 1.0 BY 0.2 HAXIS=-10 TO 10 BY 5;
symbol c=black v=line i=join;
RUN;
PROC GPLOT; 
PLOT Wnubart*nu=3/GRID FRAME HREF=0 VREF=0 VAXIS=-0.2  TO 1 BY 0.2 HAXIS=-4 TO 4 BY 1;
symbol c=black v=line i=join;
RUN;


PROC GPLOT; 
PLOT WkBT*k=3/GRID FRAME HREF=0 VAXIS=0  TO 1.0 BY 0.2 HAXIS=-10 TO 10 BY 5;
symbol c=black v=line i=join;
RUN;
PROC GPLOT; 
PLOT WnuBT*nu=3/GRID FRAME HREF=0 VREF=0 VAXIS=-0.2  TO 1 BY 0.2 HAXIS=-4 TO 4 BY 1;
symbol c=black v=line i=join;
RUN;


PROC GPLOT; 
PLOT Wkparz*k=3/GRID FRAME HREF=0 VAXIS=0  TO 1.0 BY 0.2 HAXIS=-10 TO 10 BY 5;
symbol c=black v=line i=join;
RUN;
PROC GPLOT; 
PLOT Wnuparz*nu=3/GRID FRAME HREF=0 VAXIS=0  TO 1.0 BY 0.2 HAXIS=-10 TO 10 BY 5;
symbol c=black v=line i=join;
RUN;


PROC GPLOT; 
PLOT Wkrect*k=3 Wkbart*k=3 WkBT*k=3 Wkparz*k=3/OVERLAY GRID FRAME HREF=0 VREF=0 
VAXIS=-0.5  TO 2 BY 0.2 HAXIS=-7 TO 7 BY 1;
symbol c=black v=line i=join;
RUN;

PROC GPLOT; 
PLOT Wnurect*nu=3 Wnubart*nu=3 WnuBT*nu=3 Wnuparz*nu=3/OVERLAY GRID FRAME HREF=0 VREF=0 
VAXIS=-0.5  TO 2 BY 0.2 HAXIS=-7 TO 7 BY 1;
symbol c=black v=line i=join;
RUN;