DATA linespectrum;
a1=1.5;
b2=0.75;
v1=0.0625;  /*3.141592/4;*/
v2=0.2000;  /*3.141592/3;*/

DO t=0 TO 50;
X1t=a1*cos(2*3.141592*v1*t);
X2t=b2*sin(2*3.141592*v2*t);
Xt=X1t+X2t;
OUTPUT;
END;
RUN;

PROC PRINT; VAR t X1t X2t;
RUN; 

SYMBOL1 v=dot cv=black i=spline ci=black;
SYMBOL2 v=circle cv=black i=spline ci=black;
SYMBOL3 v=none cv=black i=spline ci=black;
/* SYMBOL4 c=steelblue v=dot i=none; */
SYMBOL5 c=maroon v=diamond i=none;

PROC GPLOT;
PLOT X1t*t=3 X2t*t=2/OVERLAY VREF=0 
OVERLAY grid frame vaxis=-4.0 to 4.0 by 1 haxis=0 to 50 by 2;
PROC GPLOT;
PLOT Xt*t=3/VREF=0 
OVERLAY grid frame vaxis=-4.0 to 4.0 by 1 haxis=0 to 50 by 2;
RUN;

DATA speetrum1;
t=_N_;
DO t1=1 TO 100;
OUTPUT speetrum1;
Amplitude=t1/66.6; 
END;
RUN;
DATA speetrum2;
t=_N_;
DO t2=1 TO 200;
OUTPUT speetrum2;
cn2=t2/266.6; 
END;
RUN; 

DATA spectrumall;
MERGE speetrum1 speetrum2; BY t;
IF t1>0 THEN t1=0.0625; IF t2>0 THEN t2=0.2;
LABEL t1='Frequency';
RUN; 

PROC PRINT;
RUN; 

SYMBOL1 v=circle cv=black i=line ci=black;
SYMBOL2 v=dot cv=black i=spline ci=black; 
SYMBOL3 v=none cv=black i=join ci=black; 
SYMBOL4 v=none cv=black i=line ci=black; 
SYMBOL5 v=dot cv=black /*i=line*/ ci=black; 

PROC GPLOT DATA=spectrumall; 
PLOT Amplitude*t1=5 cn2*t2=5/OVERLAY GRID FRAME
VAXIS=0 TO 2 BY 0.2 HAXIS=0 TO 0.3 BY 0.05;
RUN;


DATA linespectrum;

v1=0.10;  /*3.141592/4;*/
v2=0.11;  /*3.141592/3;*/
v3=0.12;
v4=0.13;
v5=0.14;
v6=0.15;

DO t=0 TO 100;
X1t=1.00*sin(2*3.141592*v1*t);
X2t=0.75*sin(2*3.141592*v2*t);
X3t=0.45*sin(2*3.141592*v3*t);
X4t=0.30*sin(2*3.141592*v4*t);
X5t=0.15*sin(2*3.141592*v5*t);
X6t=0.06*sin(2*3.141592*v6*t);

Xt=X1t+X2t+X3t+X4t+X5t+X6t;
OUTPUT;
END;
RUN;

PROC PRINT; VAR t X1t X2t X3t X4t X5t X6t Xt;
RUN; 

SYMBOL1 v=dot cv=black i=spline ci=black;
SYMBOL2 v=circle cv=black i=spline ci=black;
SYMBOL3 v=none cv=black i=spline ci=black;
SYMBOL4 c=maroon v=diamond i=none;

PROC GPLOT;
PLOT X1t*t=3 X2t*t=3 X3t*t=3 X4t*t=3 X5t*t=3 X6t*t=3/OVERLAY VREF=0 
OVERLAY grid frame vaxis=-4.0 to 4.0 by 1 haxis=0 to 100 by 4;
PROC GPLOT;
PLOT Xt*t=1/VREF=0 
grid frame vaxis=-5.0 to 5.0 by 1 haxis=0 to 100 by 4;
RUN;

DATA spectrum1;
t=_N_;
DO t1=1 TO 100;
OUTPUT spectrum1;
Amplitude=t1/100; 
END;
RUN;

DATA spectrum2;
t=_N_;
DO t2=1 TO 200;
OUTPUT spectrum2;
cn2=t2/266.6;        /* 200/0.75=266.66 */
END;
RUN; 

DATA spectrum3;
t=_N_;
DO t3=1 TO 300;
OUTPUT spectrum3;
cn3=t3/666.6; 
END;
RUN;

DATA spectrum4;
t=_N_;
DO t4=1 TO 400;
OUTPUT spectrum4;
cn4=t4/1333.3; 
END;
RUN; 

DATA spectrum5;
t=_N_;
DO t5=1 TO 500;
OUTPUT spectrum5;
cn5=t5/3333.3; 
END;
RUN;

DATA spectrum6;
t=_N_;
DO t6=1 TO 600;
OUTPUT spectrum6;
cn6=t6/10000; 
END;
RUN;

DATA spectrumall;
MERGE spectrum1 spectrum2 spectrum3 spectrum4 spectrum5 spectrum6; BY t;

IF t1>0 THEN t1=0.10; 
IF t2>0 THEN t2=0.11;
IF t3>0 THEN t3=0.12; 
IF t4>0 THEN t4=0.13;
IF t5>0 THEN t5=0.14; 
IF t6>0 THEN t6=0.15; 
LABEL t1='Frequency'; 
RUN; 

PROC PRINT;
RUN; 

SYMBOL1 v=circle cv=black i=line ci=black;
SYMBOL2 v=dot cv=black i=spline ci=black; 
SYMBOL3 v=none cv=black i=join ci=black; 
SYMBOL4 v=none cv=black i=line ci=black; 
SYMBOL5 v=dot cv=black /*i=line*/ ci=black; 

PROC GPLOT DATA=spectrumall; 
PLOT Amplitude*t1=5 cn2*t2=5 cn3*t3=5 cn4*t4=5 cn5*t5=5 cn6*t6=5/OVERLAY GRID FRAME
VAXIS=0 TO 1.8 BY 0.2 HAXIS=0 TO 0.20 BY 0.05;
RUN;

DATA spectrumall2;
MERGE spectrum1 spectrum2 spectrum3 spectrum4 spectrum5 spectrum6; BY t;
IF t1>99 THEN t1=0.10; 
IF t2>199 THEN t2=0.11;
IF t3>299 THEN t3=0.12; 
IF t4>399 THEN t4=0.13;
IF t5>499 THEN t5=0.14; 
IF t6>599 THEN t6=0.15; 
LABEL t1='Frequency';
RUN; 

PROC GPLOT DATA=spectrumall2; 
PLOT Amplitude*t1=2 cn2*t2=2 cn3*t3=2 cn4*t4=2 cn5*t5=2 cn6*t6=2/OVERLAY GRID FRAME
VAXIS=0 TO 1.8 BY 0.2 HAXIS=0 TO 0.20 BY 0.05;
RUN;

DATA spectrumall3;
SET linespectrum spectrumall spectrumall2; 
t_1=0.09; 
t_2=0.08;
t_3=0.07; 
t_4=0.06;
t_5=0.05; 
t_6=0.04; 
LABEL t1='Frequency';
RUN; 

PROC GPLOT DATA=spectrumall3; 
PLOT Amplitude*t1=3 cn2*t2=3 cn3*t3=3 cn4*t4=3 cn5*t5=3 cn6*t6=3
     Amplitude*t_1=3 cn2*t_2=3 cn3*t_3=3 cn4*t_4=3 cn5*t_5=3 cn6*t_6=3
/OVERLAY GRID FRAME VAXIS=0 TO 1.8 BY 0.2 HAXIS=0 TO 0.20 BY 0.05;
RUN;

