DATA INCOMEDATA;
INFILE 'G:\BOX-ANN\INCOMES00.dat'; /* INCOMES00 for 2 target values */ 
INPUT x1 x2 x3 x4 x5 x6@@;
t=_N_;

IF t>=108 THEN DELETE; 

/* proc means; var x1 x2 x3 x4 x5 x6; run; */

x1=(x1-1684.61)/(4431.02-1684.61);  /* normalization of data */  
x2=(x2-1757.21)/(4653.94-1757.21);
x3=(x3-1832.64)/(4653.94-1832.64);
x4=(x4-1832.64)/(4653.94-1832.64);
x5=(x5-1832.64)/(4653.94-1832.64);
x6=(x6-1832.64)/(4811.14-1832.64);

/* x1=log(x1); x2=log(x2); x3=log(x3); x4=log(x4); x5=log(x5) x6=log(x6); not nece */

y5=x5; y6=x6;    /* two target values */

IF t>=108 THEN DELETE; 

/* proc print; var x1 x2 x3 x4 x5 x6; run; */

k=1;
eta=8.05; /* 8.05 3.19 4.19 0.05 1.0 eta=1.19; eta=1.2; */
/* UNIFORM RANDOM NUMBERS for weights and biases */
IF UNIFORM(1+k)<=0.5 THEN w1_11=-UNIFORM(1+k)/10; ELSE w1_11=UNIFORM(1+k)/10;
IF UNIFORM(2+k)<=0.5 THEN w1_21=-UNIFORM(2+k)/10; ELSE w1_21=UNIFORM(2+k)/10;
IF UNIFORM(3+k)<=0.5 THEN w1_12=-UNIFORM(3+k)/10; ELSE w1_12=UNIFORM(3+k)/10;
IF UNIFORM(4+k)<=0.5 THEN w1_22=-UNIFORM(4+k)/10; ELSE w1_22=UNIFORM(4+k)/10;
IF UNIFORM(5+k)<=0.5 THEN w1_13=-UNIFORM(5+k)/10; ELSE w1_13=UNIFORM(5+k)/10;
IF UNIFORM(6+k)<=0.5 THEN w1_23=-UNIFORM(6+k)/10; ELSE w1_23=UNIFORM(6+k)/10;
IF UNIFORM(7+k)<=0.5 THEN w1_14=-UNIFORM(7+k)/10; ELSE w1_14=UNIFORM(7+k)/10;
IF UNIFORM(8+k)<=0.5 THEN w1_24=-UNIFORM(8+k)/10; ELSE w1_24=UNIFORM(8+k)/10;

/* FIRST LINEAR TRANSFORMATION */
z1=w1_11*x1+w1_21*x4;  z2=w1_12*x1+w1_22*x4; 

/* FIRST ACTIVITY FUNCTION */
IF UNIFORM(9+k)<=0.5 THEN b1=-UNIFORM(9+k)/10; ELSE b1=UNIFORM(9+k)/10;
IF UNIFORM(10+k)<=0.5 THEN b2=-UNIFORM(10+k)/10; ELSE b2=UNIFORM(10+k)/10;
IF UNIFORM(11+k)<=0.5 THEN b3=-UNIFORM(11+k)/10; ELSE b3=UNIFORM(11+k)/10;
IF UNIFORM(12+k)<=0.5 THEN b4=-UNIFORM(12+k)/10; ELSE b4=UNIFORM(12+k)/10;
IF UNIFORM(13+k)<=0.5 THEN b5=-UNIFORM(13+k)/10; ELSE b5=UNIFORM(13+k)/10; 
IF UNIFORM(14+k)<=0.5 THEN b6=-UNIFORM(14+k)/10; ELSE b6=UNIFORM(14+k)/10;

/* SECOND LINEAR TRANSFORMATION */ 
IF UNIFORM(15+k)<=0.5 THEN w2_11=-UNIFORM(15+k)/10; ELSE w2_11=UNIFORM(15+k)/10;
IF UNIFORM(16+k)<=0.5 THEN w2_21=-UNIFORM(16+k)/10; ELSE w2_21=UNIFORM(16+k)/10;
IF UNIFORM(17+k)<=0.5 THEN w2_31=-UNIFORM(17+k)/10; ELSE w2_31=UNIFORM(17+k)/10;
IF UNIFORM(18+k)<=0.5 THEN w2_41=-UNIFORM(18+k)/10; ELSE w2_41=UNIFORM(18+k)/10;

IF UNIFORM(19+k)<=0.5 THEN w2_12=-UNIFORM(19+k)/10; ELSE w2_12=UNIFORM(19+k)/10;
IF UNIFORM(20+k)<=0.5 THEN w2_22=-UNIFORM(20+k)/10; ELSE w2_22=UNIFORM(20+k)/10;
IF UNIFORM(21+k)<=0.5 THEN w2_32=-UNIFORM(21+k)/10; ELSE w2_32=UNIFORM(21+k)/10;
IF UNIFORM(22+k)<=0.5 THEN w2_42=-UNIFORM(22+k)/10; ELSE w2_42=UNIFORM(22+k)/10;

s1=1/(1+exp(-(z1+b1))); 
s2=1/(1+exp(-(z2+b2)));

z5=w2_11*s1+w2_21*s2;
z6=w2_12*s1+w2_22*s2;
                 
s5=1/(1+exp(-(z5+b5))); 
s6=1/(1+exp(-(z6+b6)));

y5_hat=s5; 
y6_hat=s6;        /* These are random estimators. */

/*
proc print; var s1 s2 s3 s4 w2_11 z5 z6 s5 s6 y5_hat y6_hat;
run; */ 

/* 1ST BACKPROPAGATION step 1(right hand size) */
pLpw2_11=-1*(y5-y5_hat)*s5*(1-s5)*s1;
pLpw2_21=-1*(y5-y5_hat)*s5*(1-s5)*s2;
pLpw2_12=-1*(y6-y6_hat)*s6*(1-s6)*s1;
pLpw2_22=-1*(y6-y6_hat)*s6*(1-s6)*s2;      /* ok */

pLpb5=-1*(y5-y5_hat)*(s5*(1-s5));
pLpb6=-1*(y6-y6_hat)*(s6*(1-s6));      

/* new wights w2_11 etc  */
w2_11=w2_11-eta*pLpw2_11; w2_21=w2_21-eta*pLpw2_21; 
w2_12=w2_12-eta*pLpw2_12; w2_22=w2_22-eta*pLpw2_22; 

b5=b5-eta*pLpb5; 
b6=b6-eta*pLpb6;  

y5_hat=s5; y6_hat=s6; 

/* y5_hat=s5; y6_hat=s6;  
proc print; var t s1 s2 s3 s4 w2_11 z5 z6 s5 s6 y5_hat y6_hat;
run; */

/* 2. BACKPROPAGATION step 2(left hand side)  */

pLpw1_11=-1*(y5-y5_hat)*(s5*(1-s5)*w2_11)*(s1*(1-s1)*x1)
         -1*(y6-y6_hat)*(s6*(1-s6)*w2_12)*(s1*(1-s1)*x1);  
pLpw1_21=-1*(y5-y5_hat)*(s5*(1-s5)*w2_11)*(s1*(1-s1)*x4)  
         -1*(y6-y6_hat)*(s6*(1-s6)*w2_12)*(s1*(1-s1)*x4);  /* check ok */
pLpw1_12=-1*(y5-y5_hat)*(s5*(1-s5)*w2_21)*(s2*(1-s2)*x1) 
         -1*(y6-y6_hat)*(s6*(1-s6)*w2_22)*(s2*(1-s2)*x1); 
pLpw1_22=-1*(y5-y5_hat)*(s5*(1-s5)*w2_21)*(s2*(1-s2)*x4)
         -1*(y6-y6_hat)*(s6*(1-s6)*w2_22)*(s2*(1-s2)*x4); 

pLpb1=-1*(y5-y5_hat)*s5*(1-s5)*w2_11*s1*(1-s1)    
      -1*(y6-y6_hat)*s6*(1-s6)*w2_12*s1*(1-s1);  
pLpb2=-1*(y5-y5_hat)*s5*(1-s5)*w2_21*s2*(1-s2)
      -1*(y6-y6_hat)*s6*(1-s6)*w2_22*s2*(1-s2);  /* ok */

/* SECOND STEP for UPDATED WEIGHTS */
w1_11=w1_11-eta*pLpw1_11;       
w1_21=w1_21-eta*pLpw1_21;     
w1_12=w1_12-eta*pLpw1_12;
w1_22=w1_22-eta*pLpw1_22;

/* UPDATE biases for BACKPROPAGATION step 2 */
b1=b1-eta*pLpb1;                                     
b2=b2-eta*pLpb2; 

/* new values of z1, z2 */
z1=w1_11*x1+w1_21*x4;      
z2=w1_12*x1+w1_22*x4;

s1=1/(1+exp(-(z1+b1)));                            
s2=1/(1+exp(-(z2+b2)));

z5=w2_11*s1+w2_21*s2;
z6=w2_12*s1+w2_22*s2;
 
b5=b5-eta*pLpb5; 
b6=b6-eta*pLpb6;  
 
s5=1/(1+exp(-(z5+b5))); 
s6=1/(1+exp(-(z6+b6)));

y5_hat=s5; 
y6_hat=s6;   /* These are the 1st estimators. */

/*
proc print; var y5 y5_hat y6 y6_hat;
run; */

/* proc print; var pLpw2_11 pLpb5 w2_11 w2_12 b5 b6 s5 s6 y5_hat y6_hat;
run; */

Ry5=y5*(4811.14-1681.61)+1681.61;
Ry6=y6*(4811.14-1681.61)+1681.61;
  
Ry5_hat=y5_hat*(4811.14-1681.61)+1681.61;
Ry6_hat=y6_hat*(4811.14-1681.61)+1681.61;
               x=1; 
               DO WHILE(x<=10); 

/* 1ST BACKPROPAGATION step 1(right hand size) */

pLpw2_11=-1*(y5-y5_hat)*s5*(1-s5)*s1;
pLpw2_21=-1*(y5-y5_hat)*s5*(1-s5)*s2;
pLpw2_12=-1*(y6-y6_hat)*s6*(1-s6)*s1;
pLpw2_22=-1*(y6-y6_hat)*s6*(1-s6)*s2;

pLpb5=-1*(y5-y5_hat)*(s5*(1-s5));
pLpb6=-1*(y6-y6_hat)*(s6*(1-s6));      

/* new wights w2_11 etc  */
w2_11=w2_11-eta*pLpw2_11; w2_21=w2_21-eta*pLpw2_21; 
w2_12=w2_12-eta*pLpw2_12; w2_22=w2_22-eta*pLpw2_22; 

b5=b5-eta*pLpb5; 
b6=b6-eta*pLpb6;  

y5_hat=s5; 
y6_hat=s6;        
/* proc print; var t s1 s2 s3 s4 w2_11 z5 z6 s5 s6 y5_hat y6_hat;
run; */

/* BACKPROPAGATION step 2(left hand size) */

pLpw1_11=-1*(y5-y5_hat)*(w2_11*s5*(1-s5))*(x1*s1*(1-s1));  
pLpw1_21=-1*(y5-y5_hat)*(w2_11*s5*(1-s5))*(x4*s1*(1-s1));  
pLpw1_12=-1*(y6-y6_hat)*(w2_21*s6*(1-s6))*(x1*s2*(1-s2)); 
pLpw1_22=-1*(y6-y6_hat)*(w2_21*s6*(1-s6))*(x4*s2*(1-s2));

pLpb1=-1*(y5-y5_hat)*(s5*(1-s5)*w2_11)*(s1*(1-s1))
      -1*(y6-y6_hat)*(s6*(1-s6)*w2_12)*(s1*(1-s1));  
pLpb2=-1*(y5-y5_hat)*(s5*(1-s5)*w2_21)*(s2*(1-s2))
      -1*(y6-y6_hat)*(s6*(1-s6)*w2_22)*(s2*(1-s2));

/* SECOND STEP for UPDATED WEIGHTS */
w1_11=w1_11-eta*pLpw1_11;       
w1_21=w1_21-eta*pLpw1_21;     
w1_12=w1_12-eta*pLpw1_12;
w1_22=w1_22-eta*pLpw1_22;

/* UPDATE biases for BACKPROPAGATION step 2 */
b1=b1-eta*pLpb1;                                     
b2=b2-eta*pLpb2; 

/* new values of z1, z2 */
z1=w1_11*x1+w1_21*x4;      
z2=w1_12*x1+w1_22*x4;

s1=1/(1+exp(-(z1+b1)));                            
s2=1/(1+exp(-(z2+b2)));

z5=w2_11*s1+w2_21*s2;
z6=w2_12*s1+w2_22*s2;
 
b5=b5-eta*pLpb5; 
b6=b6-eta*pLpb6;  
 
s5=1/(1+exp(-(z5+b5))); 
s6=1/(1+exp(-(z6+b6)));

y5_hat=s5; 
y6_hat=s6;       /* These are the 2nd estimators. */


/* 
proc print; var pLtpw2_11 pLtpb5;
run; */
/* proc print; var w2_11 b5;
run; */

Ry5=y5*(4191.43-1684.61)+1684.61;
Ry6=y6*(4191.43-1684.61)+1684.61;

Ry5_hat=y5_hat*(4191.43-1684.61)+1684.61;
Ry6_hat=y6_hat*(4191.43-1684.61)+1684.61; 
 
/* MSE=(y-y_hat)**2; */                      
MSE5=(y5-y5_hat)**2;                     
MSE6=(y6-y6_hat)**2;

/* MAE=ABS(y-y_hat);  */
MAE5=ABS(y5-y5_hat);
MAE6=ABS(y6-y6_hat);

    MASE_aa5=ABS(y5-lag4(y5));
	MASE_aa6=ABS(y6-lag4(y6));
/* MASE=/0.04MAE11041; */   /* x=1: MASE_aa=0.0411041 */   
MASE5=MAE5/0.0363360;  /* x=2: MASE_aa=0.0948600 */ 
MASE6=MAE6/0.0348843;  /* x=100: MASE_aa=0.0034228 */  

/* RMSE=SQRT(MSE); */
RMSE5=SQRT(MSE5);
RMSE6=SQRT(MSE6);


IF y5=0 THEN y5=0.001; IF y6=0 THEN y6=0.001;
/* MPE5=((y5-y5_hat)/y5)*100; MPE6=((y6-y6_hat)/y6)*100;*/
MPE5=((y5-y5_hat)/y5)*100;
MPE6=((y6-y6_hat)/y6)*100; 

/* MAPE5=(ABS(y5-y5_hat)/y5)*100; MAPE6=(ABS(y6-y6_hat)/y6)*100;*/
MAPE5=(ABS(y5-y5_hat)/y5)*100;
MAPE6=(ABS(y6-y6_hat)/y6)*100; 

             OUTPUT;
             x+1;
             END; 
             RUN;  

/* IF x<1 THEN DELETE; */
/* PROC PRINT; VAR t x y_hat y1_hat y2_hat;
RUN; */
/*
PROC PRINT; VAR t y5 y5_hat y6 y6_hat;
RUN;
PROC PRINT; VAR MASE_aa;
RUN; */
/*
PROC PRINT; VAR t y5 y5_hat y6 y6_hat;
RUN; */

PROC MEANS;	VAR MASE_aa5 MASE_aa6;
RUN; 

PROC MEANS; VAR MSE5 MSE6;
RUN;

PROC MEANS; VAR MASE5 MASE6;
RUN;

PROC MEANS; VAR MAE5 MAE6;
RUN;

/* PROC MEANS; VAR MPE5 MPE6;
RUN; */

PROC MEANS; VAR MAPE5 MAPE6;
RUN;

DATA NEW1;
SET INCOMEDATA; 

/* x1=exp(x1); x2=exp(x2); x3=exp(x3); x4=exp(x4); */
 
SYMBOL1 v=dot cv=black l=1 i=line color=red;
SYMBOL2 v=circle cv=black i=line ci=black; 
SYMBOL3 v=star cv=black i=line ci=black; 
SYMBOL4 v=point cv=black i=line ci=black; 
SYMBOL5 v=none cv=black i=line ci=black; 
SYMBOL6 v=none cv=black i=spline ci=black;

/*
PROC GPLOT DATA=INCOMEDATA;   
PLOT y5*t=1 y5_hat*t=2 /OVERLAY legend GRID FRAME HREF=97.5;
RUN;

PROC GPLOT DATA=INCOMEDATA;   
PLOT y6*t=1 y6_hat*t=2 /OVERLAY legend GRID FRAME HREF=97.5;
RUN;
*/



