DATA INCOMES;
INFILE 'G:\FSAScodedata_2010\INCOMES.dat'; 
INPUT X @@;
t=_N_;
LOGX=log(X);      /* natual logarithm */
L1X=dif1(LOGX);   /* first diff for deleting linear trend */
L14X=dif4(L1X);   /* log, 1st diff, 4th diff */ 
L142X=dif2(L14X); /* log, 1st diff, 4th diff  2nd diff */ 
wt=L14X;

date=intnx('qtr', '1jan60'd,_n_-1);
format date yyq.;

IF t>96 THEN DELETE; 
SYMBOL1 v=dot cv=black i=line ci=black;
SYMBOL2 v=circle cv=black i=line ci=black;
SYMBOL3 v=none cv=black i=line ci=black;
SYMBOL4 v=none cv=black i=spline ci=black;
SYMBOL5 v=star cv=black i=line ci=black;

PROC ARIMA DATA=INCOMES;
IDENTIFY VAR=LOGX(1,4) NLAG=30;       
ESTIMATE Q=(1,2,3,4) method=CLS plot;  
FORECAST LEAD=10 OUT=out11;
RUN; 

proc print data=out11;
run;

PROC ARIMA DATA=INCOMES;
IDENTIFY VAR=LOGX(1,4) NLAG=30;       
ESTIMATE Q=(1,2,3,4,5,6,7) method=CLS plot;  
FORECAST LEAD=10 OUT=out12;
RUN; 

PROC ARIMA DATA=INCOMES;
IDENTIFY VAR=LOGX(1,4) NLAG=30;       
ESTIMATE Q=(3,4) method=CLS plot;  
FORECAST LEAD=10 OUT=out11;
RUN; 

proc print data=out12;
run;

DATA NEW;
MERGE INCOMES out11;
IF t<6 THEN DELETE;
IF t>96 THEN DELETE; /* 100 */
x_ori=exp(LOGX); fo_ori=exp(FORECAST);
L95_ori=exp(L95); U95_ori=exp(U95); res_ori=exp(RESIDUAL);
RUN;

PROC PRINT; VAR x_ori fo_ori L95_ori U95_ori res_ori;
RUN;
 
DATA NEW1;
MERGE NEW;
x_ori=exp(LOGX); 
RUN;

DATA NEW2;
SET NEW;
fo_ori=exp(FORECAST); L95_ori=exp(L95); U95_ori=exp(U95); 
RUN;

DATA NEW3;
MERGE NEW1 NEW2;
RUN;

PROC PRINT DATA=NEW3; VAR x_ori fo_ori L95_ori U95_ori;
RUN;

proc gplot DATA=NEW3;
plot x_ori*t=1 fo_ori*t=2 L95_ori*t=5 U95_ori*t /OVERLAY HREF=100.5 grid frame
haxis=1 to 115 by 10; 
run;

proc gplot DATA=NEW3;
plot x_ori*t=1 fo_ori*t=2 L95_ori*t=5 U95_ori*t=5 /OVERLAY HREF=100.5 grid frame
haxis=1 to 115 by 10; 
run;

DATA INCOMESEST;
MERGE NEW1 NEW2;

IF t<6 THEN DELETE;
IF t>96 THEN DELETE;
                     /* IF t>100 THEN DELETE; */

                                     /* note: vx_ori=y, fo_ori(fo)=y2_hat */
MSE=(x_ori-fo_ori)**2;                   /* MSE2=(y-y2_hat)**2; */
MAE=ABS(x_ori-fo_ori);                   /* MAE2=ABS(y-y2_hat); */
RMSE=SQRT((x_ori-fo_ori)**2);
MAPE=ABS((x_ori-fo_ori)/x_ori)*100;
MASE_aa=33.910842;  /* 0.1761143; */
MASE=ABS(x_ori-fo_ori)/MASE_aa;  
                       /* MASE=MAE/((91-5)*(ABS(x_ori-LAG4(x_ori)))); */

PROC MEANS; VAR MSE MASE RMSE MAE MAPE;
RUN;

DATA INCOMESEST2;
MERGE NEW1 NEW2;

/* PROC PRINT; VAR t x_ori fo_ori L95_ori U95_ori; 
RUN; */

proc gplot;
plot x_ori*t=1 fo_ori*t=2 L95_ori*t=5 U95_ori*t=5 /OVERLAY HREF=100.5 grid frame
haxis=0 to 115 by 10; 
run;

DATA INCOMESEST3; /* FOR COMPARESON */ 
MERGE NEW1 NEW2;

y=x_ori; y2_hat=fo_ori;

IF t<6 THEN DELETE;
IF t>96 THEN DELETE;

MSE2=(y-y2_hat)**2;
MASE_aa=33.910842;  /* 0.1761143; */
MASE2=ABS(y-y2_hat)/MASE_aa;   
RMSE2=SQRT(MSE2);
MAE2=ABS(y-y2_hat);
    IF y=0 THEN y=0.001;
MPE2=((y-y2_hat)/y)*100; 
MAPE2=(ABS(y-y2_hat)/y)*100; 

PROC MEANS; VAR MSE2 MASE2 RMSE2 MAE2 MAPE2;
RUN;


/* INFILE 'G:\FSAScodedata_2010\FLUR.dat'; 
INPUT t x_ori fo fo_ori L95_ori U95_ori @@; */

