DATA FREIGHT;
INFILE 'G:\BOX-ANN\FREIGHT4NOEXT.dat';  /* FREIGHTNO4.dat */
INPUT F M Q S Ftarget;                  /* F=FREIGHT M=month Q=quarter S=season  */
t=_N_; 

SYMBOL1 v=dot cv=black l=1 i=line color=red;
SYMBOL2 v=circle cv=black i=line ci=black; 
SYMBOL3 v=star cv=black i=line ci=black; 
SYMBOL4 v=point cv=black i=line ci=black; 
SYMBOL5 v=none cv=black i=line ci=black; 
SYMBOL6 v=none cv=black i=spline ci=black;

PROC GPLOT DATA=FREIGHT;  
PLOT F*t=1 /OVERLAY legend GRID FRAME; 
RUN; 
/* M*t=1 Q*t=1 S*t=1 */

F=log(F); Ftarget=log(Ftarget);
M=log(M); Q=log(Q); S=log(S);                           /* FOR CONSTANT VARIANCE */

/* PROC MEANS; VAR F Ftarget M Q S;
RUN; */

F=(F-7.0457766)/(8.1217150-7.0457766);                  /* ON [0,1] */
Ftarget=(Ftarget-7.0457766)/(8.1217150-7.0457766); 
M=(M-0)/(2.4849066-0);                                  /* ON [0,1] */
Q=(Q-0)/(1.3862944-0);   
S=(S-0)/(1.3862944-0);

SYMBOL1 v=dot cv=black l=1 i=line color=red;
SYMBOL2 v=circle cv=black i=line ci=black; 
SYMBOL3 v=star cv=black i=line ci=black; 
SYMBOL4 v=point cv=black i=line ci=black; 
SYMBOL5 v=none cv=black i=line ci=black; 
SYMBOL6 v=none cv=black i=spline ci=black;

PROC GPLOT DATA=FREIGHT;  
PLOT F*t=1 /* M*t=1 Q*t=1 S*t=1 */ /OVERLAY legend GRID FRAME; 
RUN; 

x1=F; x2=M; x3=Q; x4=S;                                 /* x1=F; x12=M; */

y=Ftarget;                                              /* target value */

SYMBOL1 v=dot cv=black l=1 i=line color=red;
SYMBOL2 v=circle cv=black i=line ci=black; 
SYMBOL3 v=star cv=black i=line ci=black; 
SYMBOL4 v=point cv=black i=line ci=black; 
SYMBOL5 v=none cv=black i=line ci=black; 
SYMBOL6 v=none cv=black i=spline ci=black;

/*
PROC PRINT; VAR t resid1 resid2 resid3 resid4; 
RUN; */

PROC GPLOT DATA=FREIGHT;  
PLOT y*t=5 /* y1_hat*t=2 y2_hat*t=3 y3_hat*t=4 y4_hat*t=1 */ 
/OVERLAY HREF=120 legend GRID FRAME; 
RUN;

PROC GPLOT DATA=FREIGHT;  
PLOT F*t=2 /* y1_hat*t=2 y2_hat*t=3 y3_hat*t=4 y4_hat*t=1 */ 
/OVERLAY HREF=120 legend GRID FRAME;
/* vaxis=1000 to 4000 by 500 haxis=1 to 150 by 10; */
RUN;


DATA DATA1;
SET FREIGHT;

PROC REG DATA=DATA1;
MODEL Ftarget=F M Q S; 
RUN;

PROC REG DATA=DATA1;
MODEL Ftarget=F M Q ; 
RUN;

PROC REG DATA=DATA1;
MODEL Ftarget=F M ; 
RUN;

PROC REG DATA=DATA1;
MODEL Ftarget=F ; 
RUN;