DATA FREIGHT;
INFILE 'G:\BOX-ANN\FREIGHT4NOEXT.dat';   /* FREIGHT4.dat  */
INPUT F M Q S Ftarget;                  /* F=FREIGHT M=month Q=quarter S=season  */
t=_N_; 
/* IF t<=120 THEN DELETE; */
/* IF t<=120 THEN DELETE;  IF t>=121 THEN DELETE; */

F=log(F); Ftarget=log(Ftarget);
M=log(M); Q=log(Q); S=log(S);                           /* FOR CONSTANT VARIANCE */

F=(F-7.0457766)/(7.9969904-7.0457766);                  /* ON [0,1] */
Ftarget=(Ftarget-7.0457766)/(7.9969904-7.0457766); 
M=(M-0)/(2.4849066-0);                                  /* ON [0,1] */
Q=(Q-0)/(1.3862944-0);   
S=(S-0)/(1.3862944-0);

x1=F; x12=Q;      /* x1=F; x12=M; */

y=Ftarget;            /* target value */

/* PROC PRINT; RUN; */

eta=6.01;             /* eta=5.503; eta=17; */ 
k=1;

/* numbers of input values 144=132+12 */
/* UNIFORM RANDOM NUMBERS for weights and biases 115 */
IF UNIFORM(1+k)<=0.5 THEN w1_11=-UNIFORM(1+k)/10; ELSE w1_11=UNIFORM(1+k)/10;
IF UNIFORM(2+k)<=0.5 THEN w1_21=-UNIFORM(2+k)/10; ELSE w1_21=UNIFORM(2+k)/10;
IF UNIFORM(3+k)<=0.5 THEN w1_12=-UNIFORM(3+k)/10; ELSE w1_12=UNIFORM(3+k)/10;
IF UNIFORM(4+k)<=0.5 THEN w1_22=-UNIFORM(4+k)/10; ELSE w1_22=UNIFORM(4+k)/10;
    /* I: first linear transformation */
z1=w1_11*x1+w1_21*x12;    
z2=w1_12*x1+w1_22*x12;    
    /* two random biases */
IF UNIFORM(5+k)<=0.5 THEN b1=-UNIFORM(5+k)/10; ELSE b1=UNIFORM(5+k)/10;
IF UNIFORM(6+k)<=0.5 THEN b2=-UNIFORM(6+k)/10; ELSE b2=UNIFORM(6+k)/10;
    /* first 2 activity functions */
s1=1/(1+exp(-(z1+b1))); 
s2=1/(1+exp(-(z2+b2)));

/* I: second linear transformation */
/* UNIFORM RANDOM NUMBERS for 2 weights */

IF UNIFORM(7+k)<=0.5 THEN w2_11=-UNIFORM(7+k)/10; ELSE w2_11=UNIFORM(7+k)/10;
IF UNIFORM(8+k)<=0.5 THEN w2_21=-UNIFORM(8+k)/10; ELSE w2_21=UNIFORM(8+k)/10; 
z3=w2_11*s1+w2_21*s2;

/* second 1 activity function */
IF UNIFORM(9+k)<=0.5 THEN b3=-UNIFORM(9+k)/10; ELSE b3=UNIFORM(9+k)/10;
s3=1/(1+exp(-(z3+b3))); 
y1_hat=s3;
                        
/* 1. BACKPROPAGATION step 1(right hand size) */  /* no more random numbers */
/* for 1st BACKPROPAGATION */

pLpw2_11=-2*(y-y1_hat)*s3*(1-s3)*s1;  
pLpw2_21=-2*(y-y1_hat)*s3*(1-s3)*s2;   

pLpb3=-2*(y-y1_hat)*(s3*(1-s3))*1;      

/* 2. new wights ws_11 etc pp13-14 first line */
w2_11=w2_11-eta*pLpw2_11;    
w2_21=w2_21-eta*pLpw2_21;   

b3=b3-eta*pLpb3;                     
     
/* 2. BACKPROPAGATION step 2(left hand size) */

pLpw1_11=-2*(y-y1_hat)*(w2_11*s3*(1-s3))*(x1*s1*(1-s1));  
pLpw1_21=-2*(y-y1_hat)*(w2_11*s3*(1-s3))*(x12*s1*(1-s1));  
pLpw1_12=-2*(y-y1_hat)*(w2_21*s3*(1-s3))*(x1*s2*(1-s2)); 
pLpw1_22=-2*(y-y1_hat)*(w2_21*s3*(1-s3))*(x12*s2*(1-s2));

pLpb1=-2*(y-y1_hat)*(w2_11*s3*(1-s3))*(1*s1*(1-s1));  
pLpb2=-2*(y-y1_hat)*(w2_21*s3*(1-s3))*(1*s2*(1-s2));

/* SECOND STEP for UPDATED WEIGHTS */

w1_11=w1_11-eta*pLpw1_11;       
w1_21=w1_21-eta*pLpw1_21;     
w1_12=w1_12-eta*pLpw1_12; 
w1_22=w1_22-eta*pLpw1_22;

/* UPDATE biases for BACKPROPAGATION step 2 */
b1=b1-eta*pLpb1;                                     
b2=b2-eta*pLpb2; 

/* new values of z1, z2 */
z1=w1_11*x1+w1_21*x12;   
z2=w1_12*x1+w1_22*x12;

s1=1/(1+exp(-(z1+b1)));   
s2=1/(1+exp(-(z2+b2)));  

z3=w2_11*s1+w2_21*s2;
s3=1/(1+exp(-(z3+b3)));              
y2_hat=s3;               /* The 2nd trained ESTIMATEE */

/* 1. BACKPROPAGATION step 1(right hand size) */

pLpw2_11=-2*(y-y2_hat)*(s3*(1-s3))*s1;   
pLpw2_21=-2*(y-y2_hat)*(s3*(1-s3))*s2;  

pLpb3=-2*(y-y2_hat)*(s3*(1-s3))*1;

/* 2. new wights ws_11 etc pp13-14 first line */

w2_11=w2_11-eta*pLpw2_11;
w2_21=w2_21-eta*pLpw2_21;

b3=b3-eta*pLpb3; 

/* 2. BACKPROPAGATION step 2(left hand size) pp.14-15 */
pLpw1_11=-2*(y-y2_hat)*(w2_11*s3*(1-s3))*(x1*s1*(1-s1)); 
pLpw1_21=-2*(y-y2_hat)*(w2_11*s3*(1-s3))*(x12*s1*(1-s1));
pLpw1_12=-2*(y-y2_hat)*(w2_21*s3*(1-s3))*(x1*s2*(1-s2));
pLpw1_22=-2*(y-y2_hat)*(w2_21*s3*(1-s3))*(x12*s2*(1-s2)); 

pLpb1=-2*(y-y2_hat)*(w2_11*s3*(1-s3))*(1*s1*(1-s1));  
pLpb2=-2*(y-y2_hat)*(w2_21*s3*(1-s3))*(1*s2*(1-s2));

w1_11=w1_11-eta*pLpw1_11;       
w1_21=w1_21-eta*pLpw1_21;     
w1_12=w1_12-eta*pLpw1_12;
w1_22=w1_22-eta*pLpw1_22;

b1=b1-eta*pLpb1; 
b2=b2-eta*pLpb2; 

/* new values of z1, z2 */
z1=w1_11*x1+w1_21*x12; 
z2=w1_12*x1+w1_22*x12;

/* UPDATED biases for BACKPROPAGATION step 2 */
s1=1/(1+exp(-(z1+b1)));                           
s2=1/(1+exp(-(z2+b2)));

z3=w2_11*s1+w2_21*s2;   
s3=1/(1+exp(-(z3+b3)));                              
           
y3_hat=s3;                  
                  
/* 2. BACKPROPAGATION step 2(left hand size) pp.14-15 */

pLpw1_11=-2*(y-y3_hat)*(w2_11*s3*(1-s3))*(x1*s1*(1-s1)); 
pLpw1_21=-2*(y-y3_hat)*(w2_11*s3*(1-s3))*(x12*s1*(1-s1));
pLpw1_12=-2*(y-y3_hat)*(w2_21*s3*(1-s3))*(x1*s2*(1-s2));
pLpw1_22=-2*(y-y3_hat)*(w2_21*s3*(1-s3))*(x12*s2*(1-s2)); 

pLpb1=-2*(y-y3_hat)*(w2_11*s3*(1-s3))*(1*s1*(1-s1));  
pLpb2=-2*(y-y3_hat)*(w2_21*s3*(1-s3))*(1*s2*(1-s2));

w1_11=w1_11-eta*pLpw1_11;       
w1_21=w1_21-eta*pLpw1_21;     
w1_12=w1_12-eta*pLpw1_12;
w1_22=w1_22-eta*pLpw1_22;

b1=b1-eta*pLpb1; 
b2=b2-eta*pLpb2; 

/* new values of z1, z2 */
z1=w1_11*x1+w1_21*x12; 
z2=w1_12*x1+w1_22*x12;

/* UPDATE biases for BACKPROPAGATION step 2 */
s1=1/(1+exp(-(z1+b1)));                           
s2=1/(1+exp(-(z2+b2)));

z3=w2_11*s1+w2_21*s2;   
s3=1/(1+exp(-(z3+b3)));                              
           
y4_hat=s3;                  
        
PROC PRINT; VAR t x1 y y1_hat y2_hat y3_hat y4_hat;    /* x1=F=FREIGHT; y=Ftarget; */
RUN; 
PROC MEANS; VAR x1 y y1_hat y2_hat y3_hat y4_hat;
RUN; 

DATA NEW1;       
SET FREIGHT;

F=F*(7.9969904-7.0457766)+7.0457766;               /* [0,1]> original unit */
Ftarget=Ftarget*(7.9969904-7.0457766)+7.0457766;
M=M*(2.4849066-0)+0;
Q=Q*(1.3862944-0)+0;
S=S*(1.3862944-0)+0;

y=y*(7.9969904-7.0457766)+7.0457766;            /* (6.4329-4.7361)+4.7361; */
y1_hat=y1_hat*(7.9969904-7.0457766)+7.0457766;   
y2_hat=y2_hat*(7.9969904-7.0457766)+7.0457766;  
y3_hat=y3_hat*(7.9969904-7.0457766)+7.0457766;  
y4_hat=y4_hat*(7.9969904-7.0457766)+7.0457766;   

error1=y-y1_hat;                                /* y=Ftarget; */
error2=y-y2_hat; 
error3=y-y3_hat; 
error4=y-y4_hat;                                

oy=exp(y);                                      /* x1=F=FREIGHT; y=Ftarget; */
oy1_hat=exp(y1_hat);                            /* original unit */ 
oy2_hat=exp(y2_hat);
oy3_hat=exp(y3_hat);
oy4_hat=exp(y4_hat);

oerror1=oy-oy1_hat;                               
oerror2=oy-oy2_hat; 
oerror3=oy-oy3_hat; 
oerror4=oy-oy4_hat;                                

MSE1=(y-y1_hat)**2; MSE2=(y-y2_hat)**2; MSE3=(y-y3_hat)**2; MSE4=(y-y4_hat)**2;  
MAE1=ABS(y-y1_hat); MAE2=ABS(y-y2_hat); MAE3=ABS(y-y3_hat); MAE4=ABS(y-y4_hat);

MPE1=((y-y1_hat)/y)*100; MPE2=((y-y2_hat)/y)*100; 
MPE3=((y-y3_hat)/y)*100; MPE4=((y-y4_hat)/y)*100;

MAPE1=(ABS((y-y1_hat)/y))*100; MAPE2=(ABS((y-y2_hat)/y))*100; 
MAPE3=(ABS((y-y3_hat)/y))*100; MAPE4=(ABS((y-y4_hat)/y))*100;

OMSE1=(oy-oy1_hat)**2; OMSE2=(oy-oy2_hat)**2; OMSE3=(oy-oy3_hat)**2; OMSE4=(oy-oy4_hat)**2;  
OMAE1=ABS(oy-oy1_hat); OMAE2=ABS(oy-oy2_hat); OMAE3=ABS(oy-oy3_hat); OMAE4=ABS(oy-oy4_hat);    

OMPE1=((oy-oy1_hat)/oy)*100; OMPE2=((oy-oy2_hat)/oy)*100; 
OMPE3=((oy-oy3_hat)/oy)*100; OMPE4=((oy-oy4_hat)/oy)*100;

OMAPE1=(ABS((oy-oy1_hat)/oy))*100; OMAPE2=(ABS((oy-oy2_hat)/oy))*100;
OMAPE3=(ABS((oy-oy3_hat)/oy))*100; OMAPE4=(ABS((oy-oy4_hat)/oy))*100;

                                       /* IF t<=120 then delete; */    
                                       /* PROC PRINT; VAR MASE_dena; RUN; */
PROC PRINT DATA=NEW1; VAR t oy oy1_hat oy2_hat oy3_hat oy4_hat;
RUN;
PROC MEANS DATA=NEW1; VAR oy oy1_hat oy2_hat oy3_hat oy4_hat;
RUN;

PROC MEANS DATA=NEW1; VAR error1 error2 error3 error4;    
RUN; 
PROC MEANS DATA=NEW1; VAR oerror1 oerror2 oerror3 oerror4;    
RUN; 

PROC MEANS DATA=NEW1; VAR MSE1 MSE2 MSE3 MSE4;            /* MASE_dena; */
RUN;
PROC MEANS DATA=NEW1; VAR MAE1 MAE2 MAE3 MAE4;
RUN; 

PROC MEANS DATA=NEW1; VAR MAPE1 MAPE2 MAPE3 MAPE4;
RUN;

PROC MEANS DATA=NEW1; VAR OMSE1 OMSE2 OMSE3 OMSE4;         /* MASE_dena; */
RUN;
PROC MEANS DATA=NEW1; VAR OMAE1 OMAE2 OMAE3 OMAE4;
RUN; 

PROC MEANS DATA=NEW1; VAR OMAPE1 OMAPE2 OMAPE3 OMAPE4;
RUN;
 
SYMBOL1 v=dot cv=black l=1 i=line color=red;
SYMBOL2 v=circle cv=black i=line ci=black; 
SYMBOL3 v=star cv=black i=line ci=black; 
SYMBOL4 v=point cv=black i=line ci=black; 
SYMBOL5 v=none cv=black i=line ci=black; 
SYMBOL6 v=none cv=black i=spline ci=black;

PROC GPLOT DATA=NEW1;  
PLOT oy*t=5 /* oy1_hat*t=2 */ oy2_hat*t=3 oy3_hat*t=2 oy4_hat*t=1 /OVERLAY legend GRID FRAME
HREF=120.5; 
/* VREF=0.5 HREF=120.5 VAXIS=0.0 TO 1.1 BY 0.1 HAXIS=0 TO 140 BY 10; */ 
RUN;

PROC GPLOT DATA=NEW1;  
PLOT oy*t=5 /* oy1_hat*t=2 oy2_hat*t=3 oy3_hat*t=2 */ oy4_hat*t=1 /OVERLAY legend GRID FRAME
HREF=120.5 VAXIS=1000 TO 3500 BY 500 HAXIS=0 TO 140 BY 10; 
RUN;

PROC GPLOT DATA=NEW1;  
PLOT oy*t=5 /* oy1_hat*t=2 */ oy2_hat*t=3 oy3_hat*t=2 oy4_hat*t=1 /OVERLAY legend GRID FRAME
HREF=120.5 VAXIS=1000 TO 3500 BY 500 HAXIS=0 TO 140 BY 10; 
RUN;

PROC GPLOT DATA=NEW1;  
PLOT error4*t=4/OVERLAY legend GRID FRAME VREF=0
HREF=120.5 VAXIS=-0.5 TO 0.5 BY 0.1 HAXIS=0 TO 140 BY 10; 
RUN;

PROC GPLOT DATA=NEW1;  
PLOT oerror4*t=4/OVERLAY legend GRID FRAME VREF=0
HREF=120.5 VAXIS=-900 TO 1000 BY 100 HAXIS=0 TO 140 BY 10; 
RUN; 

PROC GPLOT DATA=NEW1;  
PLOT oerror4*t=4/OVERLAY legend GRID FRAME VREF=0
HREF=120.5 VAXIS=-40 TO 40 BY 10 HAXIS=0 TO 140 BY 10; 
RUN;

/* PROC MEANS DATA=NEW1; VAR MASE_dena; RUN; */

/* RMSE1=SQRT(MSE1);   RMSE2=SQRT(MSE2);   RMSE3=SQRT(MSE3); RMSE4=SQRT(MSE4); */
/* ORMSE1=SQRT(OMSE1); ORMSE2=SQRT(OMSE2); ORMSE3=SQRT(OMSE3); ORMSE4=SQRT(OMSE4);  */
/* PROC MEANS DATA=NEW1; VAR ORMSE1 ORMSE2 ORMSE3 ORMSE4; RUN; */

/* PROC AUTOREG DATA=NEW1;  
MODEL oerror4=t/ NLAG=5 BACKSTEP METHOD=ML DWPROB;
OUTPUT OUT=OUT RESID=R1;
RUN; */

PROC ARIMA DATA=NEW1;  
IDENTIFY VAR=error4;
ESTIMATE P=0;
RUN;

PROC ARIMA DATA=NEW1;  
IDENTIFY VAR=oerror4;
ESTIMATE P=0;
RUN;