DATA FREIGHT;
INFILE 'F:\NSAScodedata\FREIGHT4NOEXT.dat';  /* FREIGHT4.dat */
INPUT F M Q S Ftarget;                  /* F=FREIGHT M=month Q=quarter S=season  */
t=_N_; 

F=log(F); Ftarget=log(Ftarget);
M=log(M); Q=log(Q); S=log(S);                           /* FOR CONSTANT VARIANCE */

F=(F-7.0457766)/(7.9969904-7.0457766);                  /* ON [0,1] */
Ftarget=(Ftarget-7.0457766)/(7.9969904-7.0457766); 
M=(M-0)/(2.4849066-0);                                  /* ON [0,1] */
Q=(Q-0)/(1.3862944-0);   
S=(S-0)/(1.3862944-0);

/*
PROC GPLOT DATA=FREIGHT;  
PLOT F*t=1 M*t=1 Q*t=1 S*t=1/OVERLAY legend GRID FRAME; 
RUN; */

x1=F; x2=M; x3=Q; x4=S;                                 /* x1=F; x12=M; */

y=Ftarget;                                              /* target value */

/* PROC PRINT; RUN; */

eta=5.503;                   /* keep: 11.503; eta=0.003; eta=17; eta=7.01; 0.05*/ 
k=1;

/* numbers of input values no144=132+12 */
/* UNIFORM RANDOM NUMBERS for weights and biases */
IF UNIFORM(1+k)<=0.5 THEN w1_11=-UNIFORM(1+k)/10; ELSE w1_11=UNIFORM(1+k)/10;
IF UNIFORM(2+k)<=0.5 THEN w1_21=-UNIFORM(2+k)/10; ELSE w1_21=UNIFORM(2+k)/10;
IF UNIFORM(3+k)<=0.5 THEN w1_31=-UNIFORM(3+k)/10; ELSE w1_31=UNIFORM(3+k)/10;
IF UNIFORM(4+k)<=0.5 THEN w1_41=-UNIFORM(4+k)/10; ELSE w1_41=UNIFORM(4+k)/10;
IF UNIFORM(5+k)<=0.5 THEN w1_12=-UNIFORM(5+k)/10; ELSE w1_12=UNIFORM(5+k)/10;
IF UNIFORM(6+k)<=0.5 THEN w1_22=-UNIFORM(6+k)/10; ELSE w1_22=UNIFORM(6+k)/10;
IF UNIFORM(7+k)<=0.5 THEN w1_32=-UNIFORM(7+k)/10; ELSE w1_32=UNIFORM(7+k)/10;
IF UNIFORM(8+k)<=0.5 THEN w1_42=-UNIFORM(8+k)/10; ELSE w1_42=UNIFORM(8+k)/10;
z1=w1_11*x1+w1_21*x2; /* +w1_31*x3+w1_41*x4; */  
z2=w1_12*x1+w1_22*x2; /* +w1_32*x3+w1_42*x4; */

/* 2 random biases for first 2 activity functions */
IF UNIFORM(9+k)<=0.5 THEN b1=-UNIFORM(9+k)/10; ELSE b1=UNIFORM(9+k)/10;
IF UNIFORM(10+k)<=0.5 THEN b2=-UNIFORM(10+k)/10; ELSE b2=UNIFORM(10+k)/10;
s1=1/(1+exp(-(z1+b1))); 
s2=1/(1+exp(-(z2+b2)));

                            /* RECURRENT Neural Network 1 */
IF UNIFORM(50+k)<=0.5 THEN b11=-UNIFORM(50+k)/10; ELSE b11=UNIFORM(50+k)/10;
IF UNIFORM(60+k)<=0.5 THEN b22=-UNIFORM(60+k)/10; ELSE b22=UNIFORM(60+k)/10;
z1=s1; z2=s2;
s1=1/(1+exp(-(z1+b11))); s2=1/(1+exp(-(z2+b22))); 
                            /* End of Recurrent Neural Network */

IF UNIFORM(11+k)<=0.5 THEN w2_11=-UNIFORM(11+k)/10; ELSE w2_11=UNIFORM(11+k)/10;
IF UNIFORM(12+k)<=0.5 THEN w2_21=-UNIFORM(12+k)/10; ELSE w2_21=UNIFORM(12+k)/10;
IF UNIFORM(13+k)<=0.5 THEN w2_12=-UNIFORM(13+k)/10; ELSE w2_12=UNIFORM(13+k)/10;
IF UNIFORM(14+k)<=0.5 THEN w2_22=-UNIFORM(14+k)/10; ELSE w2_22=UNIFORM(14+k)/10;
z3=w2_11*s1+w2_21*s2;    
z4=w2_12*s1+w2_22*s2; 

IF UNIFORM(15+k)<=0.5 THEN b3=-UNIFORM(15+k)/10; ELSE b3=UNIFORM(15+k)/10;
IF UNIFORM(16+k)<=0.5 THEN b4=-UNIFORM(16+k)/10; ELSE b4=UNIFORM(16+k)/10;
s3=1/(1+exp(-(z3+b3))); 
s4=1/(1+exp(-(z4+b4))); 

                              /* RECURRENT Neural Network 2 */
IF UNIFORM(51+k)<=0.5 THEN b31=-UNIFORM(51+k)/10; ELSE b31=UNIFORM(51+k)/10;
IF UNIFORM(61+k)<=0.5 THEN b32=-UNIFORM(61+k)/10; ELSE b32=UNIFORM(61+k)/10;
z3=s3; z4=s4;
s3=1/(1+exp(-(z3+b31))); s4=1/(1+exp(-(z4+b32))); 
   /* End of Recurrent Neural Network */

IF UNIFORM(17+k)<=0.5 THEN w3_11=-UNIFORM(17+k)/10; ELSE w3_11=UNIFORM(17+k)/10;
IF UNIFORM(18+k)<=0.5 THEN w3_21=-UNIFORM(18+k)/10; ELSE w3_21=UNIFORM(18+k)/10;
IF UNIFORM(19+k)<=0.5 THEN w3_12=-UNIFORM(19+k)/10; ELSE w3_12=UNIFORM(19+k)/10;
IF UNIFORM(20+k)<=0.5 THEN w3_22=-UNIFORM(20+k)/10; ELSE w3_22=UNIFORM(20+k)/10;
z5=w3_11*s3+w3_21*s4;    
z6=w3_12*s3+w3_22*s4; 

IF UNIFORM(21+k)<=0.5 THEN b5=-UNIFORM(21+k)/10; ELSE b5=UNIFORM(21+k)/10;
IF UNIFORM(22+k)<=0.5 THEN b6=-UNIFORM(22+k)/10; ELSE b6=UNIFORM(22+k)/10;
s5=1/(1+exp(-(z5+b5))); 
s6=1/(1+exp(-(z6+b6))); 

                              /* RECURRENT Neural Network 3 */
IF UNIFORM(52+k)<=0.5 THEN b41=-UNIFORM(52+k)/10; ELSE b41=UNIFORM(52+k)/10;
IF UNIFORM(62+k)<=0.5 THEN b42=-UNIFORM(62+k)/10; ELSE b42=UNIFORM(62+k)/10;
z5=s5; z6=s6;
s5=1/(1+exp(-(z5+b41))); s6=1/(1+exp(-(z6+b42))); 
                             /* End of Recurrent Neural Network */                              


IF UNIFORM(23+k)<=0.5 THEN w4_11=-UNIFORM(23+k)/10; ELSE w4_11=UNIFORM(23+k)/10;
IF UNIFORM(24+k)<=0.5 THEN w4_21=-UNIFORM(24+k)/10; ELSE w4_21=UNIFORM(24+k)/10;
z7=w4_11*s5+w4_21*s6; 

IF UNIFORM(25+k)<=0.5 THEN b7=-UNIFORM(25+k)/10; ELSE b7=UNIFORM(25+k)/10;
s7=1/(1+exp(-(z7+b7))); 

/* PROC PRINT; VAR x1 x1 x3 x4 z1 z2 s1 s2 z3 z4 s3 s4 z5 z6 s5 s6 z7 s7; 
RUN; */

y1_hat=s7;     /* The first estimate for y=Ftarget */


/* 1. BACKPROPAGATION step 1(right hand size) */  /* no more random numbers */

pLpw4_11=-2*(y-y1_hat)*y1_hat*(1-y1_hat)*s5;  
pLpw4_21=-2*(y-y1_hat)*y1_hat*(1-y1_hat)*s6;  

pLpb7=-2*(y-y1_hat)*y1_hat*(1-y1_hat);

pLpw3_11=-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_11*s5*(1-s5)*s3;  
pLpw3_21=-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_11*s5*(1-s5)*s4;  
pLpw3_12=-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_21*s6*(1-s6)*s3;  
pLpw3_22=-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_21*s6*(1-s6)*s4;  

pLpb6=-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_21*s6*(1-s6);
pLpb5=-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_11*s5*(1-s5);

pLpw2_11=
      -2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_11*s5*(1-s5)*w3_11*s3*(1-s3)*s1  
      -2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_21*s6*(1-s6)*w3_12*s3*(1-s3)*s1;

pLpw2_21=
      -2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_11*s5*(1-s5)*w3_11*s3*(1-s3)*s2  
      -2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_21*s6*(1-s6)*w3_12*s3*(1-s3)*s2;

pLpw2_12=
      -2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_11*s5*(1-s5)*w3_21*s4*(1-s4)*s1  
      -2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*s1;

pLpw2_22=
      -2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_11*s5*(1-s5)*w3_21*s4*(1-s4)*s2  
      -2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*s2;

pLpb4=-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_11*s5*(1-s5)*w3_21*s4*(1-s4)
      -2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4);
pLpb3=-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_11*s5*(1-s5)*w3_11*s3*(1-s3)
      -2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_21*s6*(1-s6)*w3_21*s3*(1-s3);

pLpw1_11=
-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_11*s6*(1-s6)*w3_11*s3*(1-s3)*w2_11*s1*(1-s1)*x1  
-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_11*s6*(1-s6)*w3_21*s4*(1-s4)*w2_12*s1*(1-s1)*x1  
-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_21*s6*(1-s6)*w3_21*s3*(1-s3)*w2_11*s1*(1-s1)*x1  
-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_12*s1*(1-s1)*x1;  

pLpw1_21=
-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_11*s6*(1-s6)*w3_11*s3*(1-s3)*w2_11*s1*(1-s1)*x2  
-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_11*s6*(1-s6)*w3_21*s3*(1-s3)*w2_12*s1*(1-s1)*x2  
-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_21*s6*(1-s6)*w3_21*s3*(1-s3)*w2_11*s1*(1-s1)*x2  
-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_21*s6*(1-s6)*w3_22*s3*(1-s3)*w2_12*s1*(1-s1)*x2;  

/*
pLpw1_31=
-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_11*s6*(1-s6)*w3_12*s3*(1-s3)*w2_11*s1*(1-s1)*x3  
-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_11*s6*(1-s6)*w3_21*s4*(1-s4)*w2_12*s1*(1-s1)*x3  
-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_22*s1*(1-s1)*x3  
-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_12*s1*(1-s1)*x3;  

pLpw1_41=
-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_11*s6*(1-s6)*w3_11*s3*(1-s3)*w2_11*s1*(1-s1)*x4  
-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_11*s6*(1-s6)*w3_21*s4*(1-s4)*w2_12*s1*(1-s1)*x4  
-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_21*s6*(1-s6)*w3_11*s3*(1-s3)*w2_11*s1*(1-s1)*x4  
-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_12*s1*(1-s1)*x4;  
*/

pLpw1_12=
-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_11*s5*(1-s5)*w3_11*s3*(1-s3)*w2_11*s2*(1-s2)*x1  
-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_11*s5*(1-s5)*w3_21*s4*(1-s4)*w2_22*s2*(1-s2)*x1  
-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_21*s5*(1-s5)*w3_21*s3*(1-s3)*w2_21*s2*(1-s2)*x1  
-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_21*s5*(1-s5)*w3_22*s4*(1-s4)*w2_22*s2*(1-s2)*x1;  

pLpw1_22=
-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_11*s5*(1-s5)*w3_11*s3*(1-s3)*w2_21*s2*(1-s2)*x2  
-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_11*s5*(1-s5)*w3_21*s4*(1-s4)*w2_22*s2*(1-s2)*x2  
-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_21*s6*(1-s6)*w3_21*s3*(1-s3)*w2_21*s2*(1-s2)*x2  
-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_22*s2*(1-s2)*x2;  

/*
pLpw1_32=
-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_11*s5*(1-s5)*w3_11*s3*(1-s3)*w2_21*s2*(1-s2)*x3  
-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_11*s5*(1-s5)*w3_21*s4*(1-s4)*w2_22*s2*(1-s2)*x3  
-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_21*s6*(1-s6)*w3_12*s3*(1-s3)*w2_21*s2*(1-s2)*x3  
-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_22*s2*(1-s2)*x3;  

pLpw1_42=
-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_11*s5*(1-s5)*w3_11*s3*(1-s3)*w2_21*s2*(1-s2)*x4  
-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_11*s5*(1-s5)*w3_21*s4*(1-s4)*w2_22*s2*(1-s2)*x4  
-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_21*s6*(1-s6)*w3_12*s3*(1-s3)*w2_21*s2*(1-s2)*x4  
-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_22*s2*(1-s2)*x4;  
*/

pLpb2=-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_11*s6*(1-s6)*w3_11*s3*(1-s3)*w2_21*s2*(1-s2)
      -2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_11*s6*(1-s6)*w3_21*s4*(1-s4)*w2_22*s2*(1-s2)
   /* -2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_21*s6*(1-s6)*w3_11*s3*(1-s3)*w2_11*s1*(1-s1) */
      -2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_22*s2*(1-s2);

pLpb1=-2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_11*s6*(1-s6)*w3_11*s3*(1-s3)*w2_11*s1*(1-s1)
      -2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_11*s6*(1-s6)*w3_21*s4*(1-s4)*w2_12*s1*(1-s1)
      -2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_21*s6*(1-s6)*w3_11*s3*(1-s3)*w2_11*s1*(1-s1)
      -2*(y-y1_hat)*y1_hat*(1-y1_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_12*s1*(1-s1);

/* SECOND STEP for UPDATED WEIGHTS */ 
w1_11=w1_11-eta*pLpw1_11;       
w1_21=w1_21-eta*pLpw1_21;     
/*
w1_31=w1_31-eta*pLpw1_31; 
w1_41=w1_41-eta*pLpw1_42; */

w1_12=w1_12-eta*pLpw1_12;       
w1_22=w1_22-eta*pLpw1_22;     

/*
w1_32=w1_32-eta*pLpw1_32; 
w1_42=w1_42-eta*pLpw1_42; */

/* UPDATE biases for BACKPROPAGATION step 2 */
b1=b1-eta*pLpb1;                                     
b2=b2-eta*pLpb2; 
b3=b3-eta*pLpb3;                                     
b4=b4-eta*pLpb4; 
b5=b5-eta*pLpb5; 
b6=b6-eta*pLpb6;                                     
b7=b7-eta*pLpb7; 
 
/* UPDATE biases for BACKPROPAGATION step 2 */
/* New values of z1,z2 */
z1=w1_11*x1+w1_21*x2; /* +w1_31*x3+w1_41*x4; */   
z2=w1_12*x1+w1_22*x2; /* +w1_32*x3+w1_42*x4; */

/* new values of s1,s2 */
s1=1/(1+exp(-(z1+b1))); 
s2=1/(1+exp(-(z2+b2)));

                          /* RECURRENT Neural Network 1 */
k=2;
IF UNIFORM(50+k)<=0.5 THEN b11=-UNIFORM(50+k)/10; ELSE b11=UNIFORM(50+k)/10;
IF UNIFORM(60+k)<=0.5 THEN b22=-UNIFORM(60+k)/10; ELSE b22=UNIFORM(60+k)/10;
z1=s1; z2=s2;
s1=1/(1+exp(-(z1+b11))); s2=1/(1+exp(-(z2+b22))); 
                            /* End of Recurrent Neural Network */
/* new values of z3,z4 */ 
z3=w2_11*s1+w2_21*s2;    
z4=w2_12*s1+w2_22*s2; 

/* new values of s3,s4 */
s3=1/(1+exp(-(z3+b3))); 
s4=1/(1+exp(-(z4+b4))); 

k=3;
                              /* RECURRENT Neural Network 2 */
IF UNIFORM(51+k)<=0.5 THEN b31=-UNIFORM(51+k)/10; ELSE b31=UNIFORM(51+k)/10;
IF UNIFORM(61+k)<=0.5 THEN b32=-UNIFORM(61+k)/10; ELSE b32=UNIFORM(61+k)/10;
z3=s3; z4=s4;
s3=1/(1+exp(-(z3+b31))); s4=1/(1+exp(-(z4+b32))); 
   /* End of Recurrent Neural Network */

/* new values of z5,z6 */
z5=w3_11*s3+w3_21*s4;    
z6=w3_12*s3+w3_22*s4; 

/* new values of s5,s6 */
s5=1/(1+exp(-(z5+b5))); 
s6=1/(1+exp(-(z6+b6))); 

k=4;
                              /* RECURRENT Neural Network 2 */
IF UNIFORM(51+k)<=0.5 THEN b31=-UNIFORM(51+k)/10; ELSE b31=UNIFORM(51+k)/10;
IF UNIFORM(61+k)<=0.5 THEN b32=-UNIFORM(61+k)/10; ELSE b32=UNIFORM(61+k)/10;
z5=s5; z6=s6;
s5=1/(1+exp(-(z5+b31))); s6=1/(1+exp(-(z6+b32))); 
   /* End of Recurrent Neural Network */

/* new values of z7 */
z7=w4_11*s5+w4_21*s6; 

/* new values of s7 */
s7=1/(1+exp(-(z7+b7))); 

y2_hat=s7;  /* The 1st ESTIMATE */

/* 2. BACKPROPAGATION step 2(left hand size) */
pLpw1_11=
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s6*(1-s6)*w3_11*s3*(1-s3)*w2_11*s1*(1-s1)*x1  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s6*(1-s6)*w3_21*s4*(1-s4)*w2_12*s1*(1-s1)*x1  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_21*s3*(1-s3)*w2_11*s1*(1-s1)*x1  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_12*s1*(1-s1)*x1;  

pLpw1_21=
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s6*(1-s6)*w3_11*s3*(1-s3)*w2_11*s1*(1-s1)*x2  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s6*(1-s6)*w3_21*s3*(1-s3)*w2_12*s1*(1-s1)*x2  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_21*s3*(1-s3)*w2_11*s1*(1-s1)*x2  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_22*s3*(1-s3)*w2_12*s1*(1-s1)*x2;  

/*
pLpw1_31=
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s6*(1-s6)*w3_12*s3*(1-s3)*w2_11*s1*(1-s1)*x3  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s6*(1-s6)*w3_21*s4*(1-s4)*w2_12*s1*(1-s1)*x3  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_22*s1*(1-s1)*x3  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_12*s1*(1-s1)*x3;  

pLpw1_41=
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s6*(1-s6)*w3_11*s3*(1-s3)*w2_11*s1*(1-s1)*x4  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s6*(1-s6)*w3_21*s4*(1-s4)*w2_12*s1*(1-s1)*x4  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_11*s3*(1-s3)*w2_11*s1*(1-s1)*x4  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_12*s1*(1-s1)*x4;  
*/

pLpw1_12=
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s5*(1-s5)*w3_11*s3*(1-s3)*w2_11*s2*(1-s2)*x1  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s5*(1-s5)*w3_21*s4*(1-s4)*w2_22*s2*(1-s2)*x1  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s5*(1-s5)*w3_21*s3*(1-s3)*w2_21*s2*(1-s2)*x1  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s5*(1-s5)*w3_22*s4*(1-s4)*w2_22*s2*(1-s2)*x1;  

pLpw1_22=
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s5*(1-s5)*w3_11*s3*(1-s3)*w2_21*s2*(1-s2)*x2  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s5*(1-s5)*w3_21*s4*(1-s4)*w2_22*s2*(1-s2)*x2  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_21*s3*(1-s3)*w2_21*s2*(1-s2)*x2  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_22*s2*(1-s2)*x2;  

/*
pLpw1_32=
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s5*(1-s5)*w3_11*s3*(1-s3)*w2_21*s2*(1-s2)*x3  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s5*(1-s5)*w3_21*s4*(1-s4)*w2_22*s2*(1-s2)*x3  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_12*s3*(1-s3)*w2_21*s2*(1-s2)*x3  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_22*s2*(1-s2)*x3;  

pLpw1_42=
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s5*(1-s5)*w3_11*s3*(1-s3)*w2_21*s2*(1-s2)*x4  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s5*(1-s5)*w3_21*s4*(1-s4)*w2_22*s2*(1-s2)*x4  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_12*s3*(1-s3)*w2_21*s2*(1-s2)*x4  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_22*s2*(1-s2)*x4;  
*/

/* SECOND STEP for UPDATED WEIGHTS */ 
w1_11=w1_11-eta*pLpw1_11;       
w1_21=w1_21-eta*pLpw1_21;     
/* w1_31=w1_31-eta*pLpw1_31; 
   w1_41=w1_41-eta*pLpw1_42; */
w1_12=w1_12-eta*pLpw1_12;       
w1_22=w1_22-eta*pLpw1_22;     
/* w1_32=w1_32-eta*pLpw1_32; 
   w1_42=w1_42-eta*pLpw1_42; */

w2_11=w2_11-eta*pLpw2_11;       
w2_21=w2_21-eta*pLpw2_21;     
w2_12=w2_12-eta*pLpw2_12; 
w2_22=w2_22-eta*pLpw2_22;

b1=b1-eta*pLpb1;                                     
b2=b2-eta*pLpb2; 
b3=b3-eta*pLpb3;                                     
b4=b4-eta*pLpb4; 
b5=b5-eta*pLpb5; 
b6=b6-eta*pLpb6;                                     
b7=b7-eta*pLpb7; 

/* UPDATE biases for BACKPROPAGATION step 2 */
/* New values of z1,z2 */
z1=w1_11*x1+w1_21*x2; /* +w1_31*x3+w1_41*x4; */  
z2=w1_12*x1+w1_22*x2; /* +w1_32*x3+w1_42*x4; */

/* new values of s1,s2 */
s1=1/(1+exp(-(z1+b1))); 
s2=1/(1+exp(-(z2+b2)));

                           /* RECURRENT Neural Network 1 */
k=2;
IF UNIFORM(50+k)<=0.5 THEN b11=-UNIFORM(50+k)/10; ELSE b11=UNIFORM(50+k)/10;
IF UNIFORM(60+k)<=0.5 THEN b22=-UNIFORM(60+k)/10; ELSE b22=UNIFORM(60+k)/10;
z1=s1; z2=s2;
s1=1/(1+exp(-(z1+b11))); s2=1/(1+exp(-(z2+b22))); 
                            /* End of Recurrent Neural Network */

/* new values of z3,z4 */ 
z3=w2_11*s1+w2_21*s2;    
z4=w2_12*s1+w2_22*s2; 

/* new values of s3,s4 */
s3=1/(1+exp(-(z3+b3))); 
s4=1/(1+exp(-(z4+b4))); 

k=3;
                              /* RECURRENT Neural Network 2 */
IF UNIFORM(51+k)<=0.5 THEN b31=-UNIFORM(51+k)/10; ELSE b31=UNIFORM(51+k)/10;
IF UNIFORM(61+k)<=0.5 THEN b32=-UNIFORM(61+k)/10; ELSE b32=UNIFORM(61+k)/10;
z3=s3; z4=s4;
s3=1/(1+exp(-(z3+b31))); s4=1/(1+exp(-(z4+b32))); 
                              /* End of Recurrent Neural Network */

/* new values of z5,z6 */
z5=w3_11*s3+w3_21*s4;    
z6=w3_12*s3+w3_22*s4; 

/* new values of s5,s6 */
s5=1/(1+exp(-(z5+b5))); 
s6=1/(1+exp(-(z6+b6))); 

k=4;
                              /* RECURRENT Neural Network 2 */
IF UNIFORM(51+k)<=0.5 THEN b31=-UNIFORM(51+k)/10; ELSE b31=UNIFORM(51+k)/10;
IF UNIFORM(61+k)<=0.5 THEN b32=-UNIFORM(61+k)/10; ELSE b32=UNIFORM(61+k)/10;
z5=s5; z6=s6;
s5=1/(1+exp(-(z5+b31))); s6=1/(1+exp(-(z6+b32))); 
   /* End of Recurrent Neural Network */

/* new values of z7 */
z7=w4_11*s5+w4_21*s6; 

/* new values of s7 */
s7=1/(1+exp(-(z7+b7))); 

y2_hat=s7;  /* The 2nd ESTIMATEE  */
     

/* 1. THE 2nd BACKPROPAGATION (right hand size) */  
pLpw1_11=
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s6*(1-s6)*w3_11*s3*(1-s3)*w2_11*s1*(1-s1)*x1  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s6*(1-s6)*w3_21*s4*(1-s4)*w2_12*s1*(1-s1)*x1  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_21*s3*(1-s3)*w2_11*s1*(1-s1)*x1  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_12*s1*(1-s1)*x1;  

pLpw1_21=
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s6*(1-s6)*w3_11*s3*(1-s3)*w2_11*s1*(1-s1)*x2  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s6*(1-s6)*w3_21*s3*(1-s3)*w2_12*s1*(1-s1)*x2  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_21*s3*(1-s3)*w2_11*s1*(1-s1)*x2  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_22*s3*(1-s3)*w2_12*s1*(1-s1)*x2;  

/*
pLpw1_31=
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s6*(1-s6)*w3_12*s3*(1-s3)*w2_11*s1*(1-s1)*x3  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s6*(1-s6)*w3_21*s4*(1-s4)*w2_12*s1*(1-s1)*x3  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_22*s1*(1-s1)*x3  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_12*s1*(1-s1)*x3;  

pLpw1_41=
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s6*(1-s6)*w3_11*s3*(1-s3)*w2_11*s1*(1-s1)*x4  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s6*(1-s6)*w3_21*s4*(1-s4)*w2_12*s1*(1-s1)*x4  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_11*s3*(1-s3)*w2_11*s1*(1-s1)*x4  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_12*s1*(1-s1)*x4; */ 


pLpw1_12=
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s5*(1-s5)*w3_11*s3*(1-s3)*w2_11*s2*(1-s2)*x1  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s5*(1-s5)*w3_21*s4*(1-s4)*w2_22*s2*(1-s2)*x1  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s5*(1-s5)*w3_21*s3*(1-s3)*w2_21*s2*(1-s2)*x1  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s5*(1-s5)*w3_22*s4*(1-s4)*w2_22*s2*(1-s2)*x1;  

pLpw1_22=
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s5*(1-s5)*w3_11*s3*(1-s3)*w2_21*s2*(1-s2)*x2  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s5*(1-s5)*w3_21*s4*(1-s4)*w2_22*s2*(1-s2)*x2  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_21*s3*(1-s3)*w2_21*s2*(1-s2)*x2  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_22*s2*(1-s2)*x2;  

/*
pLpw1_32=
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s5*(1-s5)*w3_11*s3*(1-s3)*w2_21*s2*(1-s2)*x3  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s5*(1-s5)*w3_21*s4*(1-s4)*w2_22*s2*(1-s2)*x3  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_12*s3*(1-s3)*w2_21*s2*(1-s2)*x3  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_22*s2*(1-s2)*x3;  

pLpw1_42=
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s5*(1-s5)*w3_11*s3*(1-s3)*w2_21*s2*(1-s2)*x4  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s5*(1-s5)*w3_21*s4*(1-s4)*w2_22*s2*(1-s2)*x4  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_12*s3*(1-s3)*w2_21*s2*(1-s2)*x4  
-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_22*s2*(1-s2)*x4; */ 

pLpb7=-2*(y-y2_hat)*y2_hat*(1-y2_hat);

pLpb6=-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6);

pLpb5=-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s5*(1-s5);

pLpb4=-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s5*(1-s5)*w3_21*s4*(1-s4)
      -2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4);

pLpb3=-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s5*(1-s5)*w3_11*s3*(1-s3)
      -2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_21*s3*(1-s3);


pLpb2=-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s6*(1-s6)*w3_11*s3*(1-s3)*w2_21*s2*(1-s2)
      -2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s6*(1-s6)*w3_21*s4*(1-s4)*w2_22*s2*(1-s2)
      -2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_22*s2*(1-s2);

pLpb1=-2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s6*(1-s6)*w3_11*s3*(1-s3)*w2_11*s1*(1-s1)
      -2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s6*(1-s6)*w3_21*s4*(1-s4)*w2_12*s1*(1-s1)
      -2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_11*s3*(1-s3)*w2_11*s1*(1-s1)
      -2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_12*s1*(1-s1);
     
pLpw2_11=
      -2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s5*(1-s5)*w3_11*s3*(1-s3)*s1  
      -2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_12*s3*(1-s3)*s1;

pLpw2_21=
      -2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s5*(1-s5)*w3_11*s3*(1-s3)*s2  
      -2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_12*s3*(1-s3)*s2;

pLpw2_12=
      -2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s5*(1-s5)*w3_21*s4*(1-s4)*s1  
      -2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*s1;

pLpw2_22=
      -2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s5*(1-s5)*w3_21*s4*(1-s4)*s2  
      -2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*s2;

pLpw3_11=
      -2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s5*(1-s5)*s3;  

pLpw3_21=
      -2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_11*s5*(1-s5)*s4;  

pLpw3_12=
      -2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*s3;  

pLpw3_22=
      -2*(y-y2_hat)*y2_hat*(1-y2_hat)*w4_21*s6*(1-s6)*s4;  

pLpw4_11=
      -2*(y-y2_hat)*y2_hat*(1-y2_hat)*s5;  

pLpw4_21=
      -2*(y-y2_hat)*y2_hat*(1-y2_hat)*s6;  


/* SECOND STEP for UPDATED WEIGHTS */ 
w1_11=w1_11-eta*pLpw1_11;       
w1_21=w1_21-eta*pLpw1_21;     
  /* w1_31=w1_31-eta*pLpw1_31; 
   w1_41=w1_41-eta*pLpw1_42; */
w1_12=w1_12-eta*pLpw1_12;       
w1_22=w1_22-eta*pLpw1_22;     
  /* w1_32=w1_32-eta*pLpw1_32; 
     w1_42=w1_42-eta*pLpw1_42; */

/* UPDATE biases for BACKPROPAGATION step 2 */
b1=b1-eta*pLpb1;                                     
b2=b2-eta*pLpb2; 
b3=b3-eta*pLpb3;                                     
b4=b4-eta*pLpb4; 
b5=b5-eta*pLpb5; 
b6=b6-eta*pLpb6;                                     
b7=b7-eta*pLpb7; 


/* New values of z1,z2 */
z1=w1_11*x1+w1_21*x2; /* +w1_31*x3+w1_41*x4; */  
z2=w1_12*x1+w1_22*x2; /* +w1_32*x3+w1_42*x4; */

/* new values of s1,s2 */
s1=1/(1+exp(-(z1+b1))); 
s2=1/(1+exp(-(z2+b2)));

k=3;
                           /* RECURRENT Neural Network 1 */
IF UNIFORM(50+k)<=0.5 THEN b11=-UNIFORM(50+k)/10; ELSE b11=UNIFORM(50+k)/10;
IF UNIFORM(60+k)<=0.5 THEN b22=-UNIFORM(60+k)/10; ELSE b22=UNIFORM(60+k)/10;
z1=s1; z2=s2;
s1=1/(1+exp(-(z1+b11))); s2=1/(1+exp(-(z2+b22))); 
                            /* End of Recurrent Neural Network */


/* new values of z3,z4 */ 
z3=w2_11*s1+w2_21*s2;    
z4=w2_12*s1+w2_22*s2; 

/* new values of s3,s4 */
s3=1/(1+exp(-(z3+b3))); 
s4=1/(1+exp(-(z4+b4))); 

k=4;
                           /* RECURRENT Neural Network 1 */
IF UNIFORM(50+k)<=0.5 THEN b11=-UNIFORM(50+k)/10; ELSE b11=UNIFORM(50+k)/10;
IF UNIFORM(60+k)<=0.5 THEN b22=-UNIFORM(60+k)/10; ELSE b22=UNIFORM(60+k)/10;
z3=s3; z4=s4;
s3=1/(1+exp(-(z3+b11))); s4=1/(1+exp(-(z4+b22))); 
                            /* End of Recurrent Neural Network */

/* new values of z5,z6 */
z5=w3_11*s3+w3_21*s4;    
z6=w3_12*s3+w3_22*s4; 

/* new values of s5,s6 */
s5=1/(1+exp(-(z5+b5))); 
s6=1/(1+exp(-(z6+b6))); 

k=5;
                           /* RECURRENT Neural Network 1 */
IF UNIFORM(50+k)<=0.5 THEN b11=-UNIFORM(50+k)/10; ELSE b11=UNIFORM(50+k)/10;
IF UNIFORM(60+k)<=0.5 THEN b22=-UNIFORM(60+k)/10; ELSE b22=UNIFORM(60+k)/10;
z5=s5; z6=s6;
s5=1/(1+exp(-(z5+b11))); s6=1/(1+exp(-(z5+b22))); 
                            /* End of Recurrent Neural Network */

/* new values of z7 */
z7=w4_11*s5+w4_21*s6; 

/* new values of s7 */
s7=1/(1+exp(-(z7+b7))); 
y3_hat=s7;  /* The 3rd ESTIMATEE  */

/* 1. BACKPROPAGATION step 1(right hand size) */  /* no more random numbers */
/* for 1st BACKPROPAGATION */
pLpw1_11=
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s6*(1-s6)*w3_11*s3*(1-s3)*w2_11*s1*(1-s1)*x1  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s6*(1-s6)*w3_21*s4*(1-s4)*w2_12*s1*(1-s1)*x1  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_21*s3*(1-s3)*w2_11*s1*(1-s1)*x1  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_12*s1*(1-s1)*x1;  

pLpw1_21=
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s6*(1-s6)*w3_11*s3*(1-s3)*w2_11*s1*(1-s1)*x2  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s6*(1-s6)*w3_21*s3*(1-s3)*w2_12*s1*(1-s1)*x2  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_21*s3*(1-s3)*w2_11*s1*(1-s1)*x2  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_22*s3*(1-s3)*w2_12*s1*(1-s1)*x2;  

pLpw1_31=
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s6*(1-s6)*w3_12*s3*(1-s3)*w2_11*s1*(1-s1)*x3  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s6*(1-s6)*w3_21*s4*(1-s4)*w2_12*s1*(1-s1)*x3  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_22*s1*(1-s1)*x3  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_12*s1*(1-s1)*x3;  

pLpw1_41=
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s6*(1-s6)*w3_11*s3*(1-s3)*w2_11*s1*(1-s1)*x4  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s6*(1-s6)*w3_21*s4*(1-s4)*w2_12*s1*(1-s1)*x4  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_11*s3*(1-s3)*w2_11*s1*(1-s1)*x4  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_12*s1*(1-s1)*x4;  


pLpw1_12=
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s5*(1-s5)*w3_11*s3*(1-s3)*w2_11*s2*(1-s2)*x1  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s5*(1-s5)*w3_21*s4*(1-s4)*w2_22*s2*(1-s2)*x1  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s5*(1-s5)*w3_21*s3*(1-s3)*w2_21*s2*(1-s2)*x1  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s5*(1-s5)*w3_22*s4*(1-s4)*w2_22*s2*(1-s2)*x1;  

pLpw1_22=
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s5*(1-s5)*w3_11*s3*(1-s3)*w2_21*s2*(1-s2)*x2  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s5*(1-s5)*w3_21*s4*(1-s4)*w2_22*s2*(1-s2)*x2  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_21*s3*(1-s3)*w2_21*s2*(1-s2)*x2  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_22*s2*(1-s2)*x2;  

pLpw1_32=
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s5*(1-s5)*w3_11*s3*(1-s3)*w2_21*s2*(1-s2)*x3  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s5*(1-s5)*w3_21*s4*(1-s4)*w2_22*s2*(1-s2)*x3  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_12*s3*(1-s3)*w2_21*s2*(1-s2)*x3  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_22*s2*(1-s2)*x3;  

pLpw1_42=
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s5*(1-s5)*w3_11*s3*(1-s3)*w2_21*s2*(1-s2)*x4  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s5*(1-s5)*w3_21*s4*(1-s4)*w2_22*s2*(1-s2)*x4  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_12*s3*(1-s3)*w2_21*s2*(1-s2)*x4  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_22*s2*(1-s2)*x4;  


pLpb7=-2*(y-y3_hat)*y3_hat*(1-y3_hat);

pLpb6=-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6);

pLpb5=-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s5*(1-s5);

pLpb4=-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s5*(1-s5)*w3_21*s4*(1-s4)
      -2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4);

pLpb3=-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s5*(1-s5)*w3_11*s3*(1-s3)
      -2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_21*s3*(1-s3);


pLpb2=-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s6*(1-s6)*w3_11*s3*(1-s3)*w2_21*s2*(1-s2)
      -2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s6*(1-s6)*w3_21*s4*(1-s4)*w2_22*s2*(1-s2)
      -2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_22*s2*(1-s2);

pLpb1=-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s6*(1-s6)*w3_11*s3*(1-s3)*w2_11*s1*(1-s1)
      -2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s6*(1-s6)*w3_21*s4*(1-s4)*w2_12*s1*(1-s1)
      -2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_11*s3*(1-s3)*w2_11*s1*(1-s1)
      -2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_12*s1*(1-s1);
     
pLpw2_11=
      -2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s5*(1-s5)*w3_11*s3*(1-s3)*s1  
      -2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_12*s3*(1-s3)*s1;

pLpw2_21=
      -2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s5*(1-s5)*w3_11*s3*(1-s3)*s2  
      -2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_12*s3*(1-s3)*s2;

pLpw2_12=
      -2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s5*(1-s5)*w3_21*s4*(1-s4)*s1  
      -2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*s1;

pLpw2_22=
      -2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s5*(1-s5)*w3_21*s4*(1-s4)*s2  
      -2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*s2;

pLpw3_11=
      -2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s5*(1-s5)*s3;  

pLpw3_21=
      -2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s5*(1-s5)*s4;  

pLpw3_12=
      -2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*s3;  

pLpw3_22=
      -2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*s4;  

pLpw4_11=
      -2*(y-y3_hat)*y3_hat*(1-y3_hat)*s5;  

pLpw4_21=
      -2*(y-y3_hat)*y3_hat*(1-y3_hat)*s6;  

/* SECOND STEP for UPDATED WEIGHTS */ 
w1_11=w1_11-eta*pLpw1_11;       
w1_21=w1_21-eta*pLpw1_21;     
w1_31=w1_31-eta*pLpw1_31; 
w1_41=w1_41-eta*pLpw1_41;
w1_12=w1_12-eta*pLpw1_12;       
w1_22=w1_22-eta*pLpw1_22;     
w1_32=w1_32-eta*pLpw1_32; 
w1_42=w1_42-eta*pLpw1_42;

/* UPDATE biases for BACKPROPAGATION step 2 */
b1=b1-eta*pLpb1;                                     
b2=b2-eta*pLpb2; 
b3=b3-eta*pLpb3;                                     
b4=b4-eta*pLpb4; 
b5=b5-eta*pLpb5; 
b6=b6-eta*pLpb6;                                     
b7=b7-eta*pLpb7; 
 
/* 2. BACKPROPAGATION step 2(left hand size) */
pLpw1_11=
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s6*(1-s6)*w3_11*s3*(1-s3)*w2_11*s1*(1-s1)*x1  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s6*(1-s6)*w3_21*s4*(1-s4)*w2_12*s1*(1-s1)*x1  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_21*s3*(1-s3)*w2_11*s1*(1-s1)*x1  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_12*s1*(1-s1)*x1;  

pLpw1_21=
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s6*(1-s6)*w3_11*s3*(1-s3)*w2_11*s1*(1-s1)*x2  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s6*(1-s6)*w3_21*s3*(1-s3)*w2_12*s1*(1-s1)*x2  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_21*s3*(1-s3)*w2_11*s1*(1-s1)*x2  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_22*s3*(1-s3)*w2_12*s1*(1-s1)*x2;  

pLpw1_31=
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s6*(1-s6)*w3_12*s3*(1-s3)*w2_11*s1*(1-s1)*x3  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s6*(1-s6)*w3_21*s4*(1-s4)*w2_12*s1*(1-s1)*x3  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_22*s1*(1-s1)*x3  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_12*s1*(1-s1)*x3;  

pLpw1_41=
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s6*(1-s6)*w3_11*s3*(1-s3)*w2_11*s1*(1-s1)*x4  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s6*(1-s6)*w3_21*s4*(1-s4)*w2_12*s1*(1-s1)*x4  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_11*s3*(1-s3)*w2_11*s1*(1-s1)*x4  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_12*s1*(1-s1)*x4;  

pLpw1_12=
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s5*(1-s5)*w3_11*s3*(1-s3)*w2_11*s2*(1-s2)*x1  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s5*(1-s5)*w3_21*s4*(1-s4)*w2_22*s2*(1-s2)*x1  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s5*(1-s5)*w3_21*s3*(1-s3)*w2_21*s2*(1-s2)*x1  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s5*(1-s5)*w3_22*s4*(1-s4)*w2_22*s2*(1-s2)*x1;  

pLpw1_22=
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s5*(1-s5)*w3_11*s3*(1-s3)*w2_21*s2*(1-s2)*x2  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s5*(1-s5)*w3_21*s4*(1-s4)*w2_22*s2*(1-s2)*x2  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_21*s3*(1-s3)*w2_21*s2*(1-s2)*x2  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_22*s2*(1-s2)*x2;  

pLpw1_32=
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s5*(1-s5)*w3_11*s3*(1-s3)*w2_21*s2*(1-s2)*x3  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s5*(1-s5)*w3_21*s4*(1-s4)*w2_22*s2*(1-s2)*x3  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_12*s3*(1-s3)*w2_21*s2*(1-s2)*x3  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_22*s2*(1-s2)*x3;  

pLpw1_42=
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s5*(1-s5)*w3_11*s3*(1-s3)*w2_21*s2*(1-s2)*x4  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_11*s5*(1-s5)*w3_21*s4*(1-s4)*w2_22*s2*(1-s2)*x4  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_12*s3*(1-s3)*w2_21*s2*(1-s2)*x4  
-2*(y-y3_hat)*y3_hat*(1-y3_hat)*w4_21*s6*(1-s6)*w3_22*s4*(1-s4)*w2_22*s2*(1-s2)*x4;  

/* SECOND STEP for UPDATED WEIGHTS */ 
w1_11=w1_11-eta*pLpw1_11;       
w1_21=w1_21-eta*pLpw1_21;     
/* w1_31=w1_31-eta*pLpw1_31; 
   w1_41=w1_41-eta*pLpw1_42; */

w1_12=w1_12-eta*pLpw1_12;       
w1_22=w1_22-eta*pLpw1_22;     
/* w1_32=w1_32-eta*pLpw1_32; 
   w1_42=w1_42-eta*pLpw1_42; */

/* UPDATE biases for BACKPROPAGATION step 2 */
b1=b1-eta*pLpb1;                                     
b2=b2-eta*pLpb2; 
b3=b3-eta*pLpb3;                                     
b4=b4-eta*pLpb4; 
b5=b5-eta*pLpb5; 
b6=b6-eta*pLpb6;                                     
b7=b7-eta*pLpb7; 

/* new values of z1,z2 */
z1=w1_11*x1+w1_21*x2; /* +w1_31*x3+w1_41*x4; */   
z2=w1_12*x1+w1_22*x2; /* +w1_32*x3+w1_42*x4; */

/* new values of s1,s2 */
s1=1/(1+exp(-(z1+b1))); 
s2=1/(1+exp(-(z2+b2)));

k=6;
                           /* RECURRENT Neural Network 1 */
IF UNIFORM(50+k)<=0.5 THEN b11=-UNIFORM(50+k)/10; ELSE b11=UNIFORM(50+k)/10;
IF UNIFORM(60+k)<=0.5 THEN b22=-UNIFORM(60+k)/10; ELSE b22=UNIFORM(60+k)/10;
z1=s1; z2=s2;
s1=1/(1+exp(-(z1+b11))); s2=1/(1+exp(-(z2+b22))); 
                            /* End of Recurrent Neural Network */


/* new values of z3,z4 */ 
z3=w2_11*s1+w2_21*s2;    
z4=w2_12*s1+w2_22*s2; 

/* new values of s3,s4 */
s3=1/(1+exp(-(z3+b3))); 
s4=1/(1+exp(-(z4+b4))); 

k=7;
                           /* RECURRENT Neural Network 1 */
IF UNIFORM(50+k)<=0.5 THEN b11=-UNIFORM(50+k)/10; ELSE b11=UNIFORM(50+k)/10;
IF UNIFORM(60+k)<=0.5 THEN b22=-UNIFORM(60+k)/10; ELSE b22=UNIFORM(60+k)/10;
z3=s3; z4=s4;
s3=1/(1+exp(-(z3+b11))); s4=1/(1+exp(-(z4+b22))); 
                            /* End of Recurrent Neural Network */

/* new values of z5,z6 */
z5=w3_11*s3+w3_21*s4;    
z6=w3_12*s3+w3_22*s4; 

/* new values of s5,s6 */
s5=1/(1+exp(-(z5+b5))); 
s6=1/(1+exp(-(z6+b6))); 

k=8;
                           /* RECURRENT Neural Network 1 */
IF UNIFORM(50+k)<=0.5 THEN b11=-UNIFORM(50+k)/10; ELSE b11=UNIFORM(50+k)/10;
IF UNIFORM(60+k)<=0.5 THEN b22=-UNIFORM(60+k)/10; ELSE b22=UNIFORM(60+k)/10;
z5=s5; z6=s6;
s5=1/(1+exp(-(z5+b11))); s6=1/(1+exp(-(z6+b22))); 
                            /* End of Recurrent Neural Network */

/* new values of z7 */
z7=w4_11*s5+w4_21*s6; 

/* new values of s7 */
s7=1/(1+exp(-(z7+b7))); 
y4_hat=s7;  /* The 4th ESTIMATEE after ... */

PROC PRINT; VAR y1_hat y2_hat y3_hat y4_hat;
RUN;

PROC MEANS; VAR y1_hat y2_hat y3_hat y4_hat;
RUN;

DATA NEW1;
SET FREIGHT;

MSE1=(y-y1_hat)**2;                     
MSE2=(y-y2_hat)**2; 
MSE3=(y-y3_hat)**2;                     
MSE4=(y-y4_hat)**2; 

MAE1=ABS(y-y1_hat);
MAE2=ABS(y-y2_hat);
MAE3=ABS(y-y3_hat);
MAE4=ABS(y-y4_hat); 


y5=lag5(y);

RMSE1=SQRT(MSE1);
RMSE2=SQRT(MSE2);
RMSE3=SQRT(MSE3);
RMSE4=SQRT(MSE4);  

IF y=0 THEN y=0.001;
MPE1=((y-y1_hat)/y)*100;
MPE2=((y-y2_hat)/y)*100; 
MPE3=((y-y3_hat)/y)*100;
MPE4=((y-y4_hat)/y)*100; 

MAPE1=(ABS((y-y1_hat)/y))*100;
MAPE2=(ABS((y-y2_hat)/y))*100;
MAPE3=(ABS((y-y3_hat)/y))*100;
MAPE4=(ABS((y-y4_hat)/y))*100; 

/* MASE_dena=(abs(y-lag5(y))); */

/* proc print; var y2_hat;
run; */
 
PROC MEANS DATA=NEW1; VAR MSE1 MSE2 MSE3 MSE4;
RUN;

PROC MEANS DATA=NEW1; VAR MAE1 MAE2 MAE3 MAE4;
RUN; 

PROC MEANS DATA=NEW1; VAR MAPE1 MAPE2 MAPE3 MAPE4;
RUN;
 
/* PROC MEANS DATA=NEW1; VAR MASE_dena;
RUN; */
/*
PROC MEANS DATA=NEW1; VAR MPE1 MPE2;
RUN; */ 

/* PROC MEANS DATA=NEW1; VAR MASE_dena;    
RUN; */

PROC PRINT; VAR t y y1_hat y2_hat y3_hat y4_hat; 
RUN; 

PROC MEANS; VAR y y1_hat y2_hat y3_hat y4_hat;
RUN; 
 
DATA NEW2;       
SET NEW1;

resid1=y-y1_hat; 
resid2=y-y2_hat; 
resid3=y-y3_hat; 
resid4=y-y4_hat; 

SYMBOL1 v=dot cv=black l=1 i=line color=red;
SYMBOL2 v=circle cv=black i=line ci=black; 
SYMBOL3 v=star cv=black i=line ci=black; 
SYMBOL4 v=point cv=black i=line ci=black; 
SYMBOL5 v=none cv=black i=line ci=black; 
SYMBOL6 v=none cv=black i=spline ci=black;

PROC PRINT; VAR t resid1 resid2 resid3 resid4 resid44; 
RUN; 

PROC GPLOT DATA=NEW2;  
PLOT y*t=5 /* y1_hat*t=2 y2_hat*t=3 */ y3_hat*t=4 y4_hat*t=1
/OVERLAY HREF=120 legend GRID FRAME; 
RUN;

PROC GPLOT DATA=NEW2;  
PLOT resid1*t=5 resid2*t=2 resid3*t=3/OVERLAY HREF=120 legend GRID FRAME 
VREF=0 HREF=120 VAXIS=-1.0 TO 1.0 BY 0.1 HAXIS=0 TO 140 BY 10;  
RUN; 

DATA NEW3;       
SET NEW2;

F=F*(7.9969904-7.0457766)+7.0457766;               /* [0,1]> original unit */
Ftarget=Ftarget*(7.9969904-7.0457766)+7.0457766;
M=M*(2.4849066-0)+0;
Q=Q*(1.3862944-0)+0;
S=S*(1.3862944-0)+0;

y=y*(7.9969904-7.0457766)+7.0457766;            /* (6.4329-4.7361)+4.7361; */
y1_hat=y1_hat*(7.9969904-7.0457766)+7.0457766;   
y2_hat=y2_hat*(7.9969904-7.0457766)+7.0457766;  
y3_hat=y3_hat*(7.9969904-7.0457766)+7.0457766;  
y4_hat=y4_hat*(7.9969904-7.0457766)+7.0457766;   

error1=y-y1_hat;                                /* y=Ftarget; */
error2=y-y2_hat; 
error3=y-y3_hat; 
error4=y-y4_hat;                                

oy=exp(y);                                      /* x1=F=FREIGHT; y=Ftarget; */
oy1_hat=exp(y1_hat);                            /* original unit */ 
oy2_hat=exp(y2_hat);
oy3_hat=exp(y3_hat);
oy4_hat=exp(y4_hat); 


oerror1=oy-oy1_hat;                               
oerror2=oy-oy2_hat; 
oerror3=oy-oy3_hat; 
oerror4=oy-oy4_hat;                                

MSE1=(y-y1_hat)**2; MSE2=(y-y2_hat)**2; MSE3=(y-y3_hat)**2; MSE4=(y-y4_hat)**2; 

MAE1=ABS(y-y1_hat); MAE2=ABS(y-y2_hat); MAE3=ABS(y-y3_hat); MAE4=ABS(y-y4_hat);

MPE1=((y-y1_hat)/y)*100; MPE2=((y-y2_hat)/y)*100; 
MPE3=((y-y3_hat)/y)*100; MPE4=((y-y4_hat)/y)*100; 

MAPE1=(ABS((y-y1_hat)/y))*100; MAPE2=(ABS((y-y2_hat)/y))*100; 
MAPE3=(ABS((y-y3_hat)/y))*100; MAPE4=(ABS((y-y4_hat)/y))*100; 
OMSE1=(oy-oy1_hat)**2; OMSE2=(oy-oy2_hat)**2; OMSE3=(oy-oy3_hat)**2; OMSE4=(oy-oy4_hat)**2; 
 
OMAE1=ABS(oy-oy1_hat); OMAE2=ABS(oy-oy2_hat); OMAE3=ABS(oy-oy3_hat); 
OMAE4=ABS(oy-oy4_hat);     

OMPE1=((oy-oy1_hat)/oy)*100; OMPE2=((oy-oy2_hat)/oy)*100; 
OMPE3=((oy-oy3_hat)/oy)*100; OMPE4=((oy-oy4_hat)/oy)*100; 

OMAPE1=(ABS((oy-oy1_hat)/oy))*100; OMAPE2=(ABS((oy-oy2_hat)/oy))*100;
OMAPE3=(ABS((oy-oy3_hat)/oy))*100; OMAPE4=(ABS((oy-oy4_hat)/oy))*100;

                                       /* IF t<=120 then delete; */    
                                       /* PROC PRINT; VAR MASE_dena; RUN; */
PROC PRINT DATA=NEW3; VAR t oy oy1_hat oy2_hat oy3_hat oy4_hat;
RUN;
PROC MEANS DATA=NEW3; VAR oy oy1_hat oy2_hat oy3_hat oy4_hat;
RUN;

PROC MEANS DATA=NEW3; VAR error1 error2 error3 error4;    
RUN; 
PROC MEANS DATA=NEW3; VAR oerror1 oerror2 oerror3 oerror4;    
RUN; 

PROC MEANS DATA=NEW3; VAR MSE1 MSE2 MSE3 MSE4;            /* MASE_dena; */
RUN;
PROC MEANS DATA=NEW3; VAR MAE1 MAE2 MAE3 MAE4;
RUN; 

PROC MEANS DATA=NEW3; VAR MAPE1 MAPE2 MAPE3 MAPE4;
RUN;

PROC MEANS DATA=NEW3; VAR OMSE1 OMSE2 OMSE3 OMSE4;         /* MASE_dena; */
RUN;
PROC MEANS DATA=NEW3; VAR OMAE1 OMAE2 OMAE3 OMAE4;
RUN; 

PROC MEANS DATA=NEW3; VAR OMAPE1 OMAPE2 OMAPE3 OMAPE4;
RUN;
 
SYMBOL1 v=dot cv=black l=1 i=line color=red;
SYMBOL2 v=circle cv=black i=line ci=black; 
SYMBOL3 v=star cv=black i=line ci=black; 
SYMBOL4 v=point cv=black i=line ci=black; 
SYMBOL5 v=none cv=black i=line ci=black; 
SYMBOL6 v=none cv=black i=spline ci=black;

PROC GPLOT DATA=NEW3;  
PLOT oy*t=5 /* oy1_hat*t=2 */ oy2_hat*t=3 oy3_hat*t=2*/ 
oy4_hat*t=1/OVERLAY legend GRID FRAME
HREF=120.5; 
/* VREF=0.5 HREF=120.5 VAXIS=0.0 TO 1.1 BY 0.1 HAXIS=0 TO 140 BY 10; */ 
RUN;

PROC GPLOT DATA=NEW3;  
PLOT oy*t=4 oy2_hat*t=3 oy3_hat*t=2 oy4_hat*t=1/OVERLAY legend GRID FRAME
HREF=120.5 VAXIS=1000 TO 3500 BY 500 HAXIS=0 TO 140 BY 10; 
RUN;

PROC GPLOT DATA=NEW3;  
PLOT oy*t=5 oy3_hat*t=2 oy4_hat*t=1 
/OVERLAY legend GRID FRAME
HREF=120.5 VAXIS=1000 TO 3500 BY 500 HAXIS=0 TO 140 BY 10; 
RUN;

PROC GPLOT DATA=NEW3;  
PLOT error3*t=3 error4*t=4/OVERLAY legend GRID FRAME VREF=0
HREF=120.5 VAXIS=-0.5 TO 0.5 BY 0.1 HAXIS=0 TO 140 BY 10; 
RUN;

PROC GPLOT DATA=NEW3;  
PLOT oerror3*t=3 oerror4*t=4/OVERLAY legend GRID FRAME VREF=0
HREF=120.5 VAXIS=-900 TO 1000 BY 100 HAXIS=0 TO 140 BY 10; 
RUN; 

PROC GPLOT DATA=NEW3;  
PLOT oerror3*t=3 oerror4*t=4/OVERLAY legend GRID FRAME VREF=0
HREF=120.5 VAXIS=-100 TO 100 BY 10 HAXIS=0 TO 140 BY 10; 
RUN;

PROC ARIMA DATA=NEW3;  
IDENTIFY VAR=error4;
ESTIMATE P=0;
RUN;

PROC ARIMA DATA=NEW3;  
IDENTIFY VAR=oerror4;
ESTIMATE P=0;
RUN;

DATA NEW4;       
SET NEW1 NEW2 NEW3;
PROC CORR DATA=NEW3;
VAR Y X1-X4;
RUN;

PROC REG DATA=NEW3; DROP X1-X4;
MODEL Y=X1-X4/DW VIF COLLINOINT INFLUENCE PARTIAL STB;
OUTPUT OUT=GRAPH PREDICTED=P RESIDUAL=R STUDENT=STUDENT RSTUDENT=RSTUDENT;
RUN;
 


