DATA sunspot;
INFILE 'G:\BOX-ANN\SUNSPOT.dat';
INPUT SUN @@;
SUN=SUN-49.6448;

DATA zeros;
INPUT SUN @@;
LINES;
0 0 0 0 0 0 0 0 0 0
0 0 0 0 0 0 0 0 0 0
0 0 0 0 0 0 0 0 0 0
0 0 0 0 0 0 0 0 0 0
0 0 0 0 0 0 0 0 0 0
0 0 0
;

/* PROC PRINT; VAR t SUN;
RUN; */

SYMBOL1 v=dot cv=black i=line ci=black;
SYMBOL2 v=circle cv=black i=spline ci=black; 
SYMBOL3 v=none cv=black i=join ci=black; 
SYMBOL4 v=none cv=black i=line ci=black; 
SYMBOL5 v=none cv=black i=spline ci=black; 

DATA join1;
SET sunspot zeros;
t=_N_;
RUN; 
PROC SPECTRA p s adjmean out=out1;
VAR SUN;
run;
PROC GPLOT DATA=out1;
PLOT (s_01)*(freq)=3;
run;

DATA join2;
SET sunspot zeros;
t=_N_;
RUN; 
PROC SPECTRA p s adjmean out=out2;
VAR SUN;
weights 1 1 1; 
run;
PROC GPLOT DATA=out2;
PLOT (s_01)*(freq)=3;
run;

DATA join3;
SET sunspot zeros;
t=_N_;
RUN; 
PROC SPECTRA p s adjmean out=out3;
VAR SUN;
weights 1 1 1 1 1; 
run;

PROC GPLOT DATA=out3;
PLOT (s_01)*(freq)=5;
run;

DATA final1;
SET out2;
lns_01=LOG(s_01);    

DATA final2;
SET out3;
lns_02=LOG(s_01); 

DATA final;
MERGE final1 final2;
RUN;
 
PROC PRINT DATA=final;
RUN;

PROC GPLOT DATA=final;
PLOT (lns_01)*(freq)=4 (lns_02)*(freq)=4/OVERLAY;
run;
