DATA waterdata;
INFILE 'G:\BOX-ANN\WATER3.dat';
INPUT X @@;
t=_N_;
Z=DIF12(X);
 
PROC PRINT; VAR t X Z;
RUN;
 
SYMBOL1 v=dot cv=black i=spline ci=black;
SYMBOL2 v=circle cv=black i=spline ci=black;
SYMBOL3 v=none cv=black i=spline ci=black;

PROC GPLOT DATA=waterdata;
PLOT Z*t=1/OVERLAY GRID VREF=0 FRAME VAXIS=-10 TO 10 BY 2 HAXIS=0 TO 270 BY 24;
RUN;
 
PROC ARIMA DATA=waterdata;
IDENTIFY VAR=X(12) NLAG=36;    
ESTIMATE Q=(12,24) method=ML;
FORECAST LEAD=5 OUT=out1;
RUN;

PROC ARIMA DATA=out1; 
IDENTIFY VAR=residual NLAG=60;    
ESTIMATE Q=(1,2) method=ML;
FORECAST LEAD=5 OUT=out2;
RUN;

PROC ARIMA DATA=waterdata;
IDENTIFY VAR=X(12) NLAG=36;    
ESTIMATE Q=(1,2)(12,24) method=ML;
FORECAST LEAD=5 OUT=out3;
RUN;

DATA new;
MERGE waterdata out3; 
RUN;

PROC PRINT; 
RUN;

PROC GPLOT DATA=new;
PLOT RESIDUAL*t=1/OVERLAY GRID VREF=0 FRAME VAXIS=-10 TO 10 BY 2 HAXIS=0 TO 270 BY 24;
RUN;
 
PROC ARIMA DATA=out3;
IDENTIFY VAR=RESIDUAL NLAG=60;    
RUN;