DATA PASSENGER; 
INFILE 'G:\BOX-ANN\passenger.dat';
INPUT ps @@; 
z=log(ps);                                   
z1=z-lag1(z);                 
z12=z-lag12(z);
z112=z12-lag1(z12);
t=_N_;
IF t>132 THEN DELETE;  
RUN;

SYMBOL1 v=dot cv=black i=line ci=black;
SYMBOL2 v=circle cv=black i=line ci=black;
SYMBOL3 v=none cv=black i=line ci=black;
SYMBOL4 v=none cv=black i=spline ci=black;
 
proc gplot DATA=PASSENGER;
plot ps*t=1/vref=0 vaxis=100 to 700 by 50;              /* vref=17.06 vaxis=15 to 19 by 1;*/ 
plot z*t=1/vref=0 vaxis=4.5 to 6.5 by 0.5; 
plot z1*t=1/vref=0 vaxis=-0.5 to 0.5 by 0.1; 
plot z12*t=1/vaxis=0.0 to 0.5 by 0.1; 
plot z112*t=1/vref=0 vaxis=-0.3 to 0.3 by 0.1; 
run;

PROC ARIMA DATA=PASSENGER;
IDENTIFY VAR=z(1) NLAG=60;
RUN; 

PROC ARIMA DATA=PASSENGER;
IDENTIFY VAR=z(12) NLAG=60;
RUN; 

PROC ARIMA DATA=PASSENGER;
IDENTIFY VAR=z(1,12) NLAG=60;
RUN; 

PROC ARIMA DATA=PASSENGER;
IDENTIFY VAR=z(1,12) NLAG=60;
ESTIMATE Q=(1,2)(12) METHOD=ml plot; 
FORECAST LEAD=12 OUT=out10;
RUN; 

proc print data=out10;
run;

DATA NEW;
MERGE PASSENGER out10;
RUN;

proc gplot DATA=NEW;
plot RESIDUAL*t=3/vref=0 vaxis=-0.5 to 0.5 by 0.2;             
run;

PROC UNIVARIATE DATA=OUT10 NORMAL PLOT; 
VAR RESIDUAL;
RUN;


PROC ARIMA DATA=PASSENGER; 
IDENTIFY VAR=z112 NLAG=30;    /* VAR=z(1,12) */
ESTIMATE Q=(1,2)(12) method=ML plot;  /* Q=(1,2)(12) CLS */
FORECAST LEAD=10 OUT=out10;
RUN;