DATA employdata;
INFILE 'G:\BOX-JENKINS\EMPLOY.dat';
INPUT X @@;
t=_N_;
X1=DIF1(X);
X12=DIF12(X1);
 
PROC PRINT; VAR t X X1 X12;
RUN;
 
SYMBOL1 v=dot cv=black i=spline ci=black;
SYMBOL2 v=circle cv=black i=spline ci=black;
SYMBOL3 v=none cv=black i=spline ci=black;

PROC GPLOT DATA=employdata;
PLOT X*t=1/OVERLAY GRID VREF=826.4697 FRAME VAXIS=200 TO 1600 BY 200 HAXIS=0 TO 130 BY 6;
RUN;

PROC REG DATA=employdata;
MODEL X=t;
OUTPUT OUT=first P=PREDICT R=RESID;
RUN;

PROC GPLOT DATA=first;
PLOT X*t PREDICT*t/OVERLAY GRID VREF=826.4697 FRAME VAXIS=200 TO 1600 BY 200 HAXIS=0 TO 130 BY 6;
RUN;

PROC ARIMA DATA=employdata;
IDENTIFY VAR=X NLAG=36;    
RUN;

PROC GPLOT DATA=employdata;
PLOT X1*t=1/OVERLAY GRID VREF=0 FRAME VAXIS=-800 TO 1000 BY 200 HAXIS=0 TO 130 BY 6;
RUN;

PROC ARIMA DATA=employdata;
IDENTIFY VAR=X(1) NLAG=36;    
RUN;

PROC GPLOT DATA=employdata;
PLOT X12*t=1/OVERLAY GRID VREF=0 FRAME VAXIS=-1000 TO 1000 BY 200 HAXIS=12 TO 132 BY 6;
RUN;

PROC ARIMA DATA=employdata;
IDENTIFY VAR=X(1,12) NLAG=36;    
ESTIMATE P=(0)(0) Q=(0)(12) method=ML;
FORECAST LEAD=12 OUT=out1; 
RUN;

PROC ARIMA DATA=out1; 
IDENTIFY VAR=residual NLAG=60;    
RUN;

PROC ARIMA DATA=employdata;
IDENTIFY VAR=X(1,12) NLAG=36;    
ESTIMATE P=(0)(0) Q=(1)(12) method=ML;
FORECAST LEAD=12 OUT=out2;
RUN;

PROC ARIMA DATA=out2; 
IDENTIFY VAR=residual NLAG=60;    
RUN;


