DATA analy;
INFILE 'G:\BOX-ANN\HOTEL3.dat';
INPUT q x @@;
t=_N_;
DATE=INTNX('quarter','1jan58'd,_N_-1); 
format date yyq5.;

x_c=x-1141.87; 
DIFF1=dif1(x);
DIFF1_c=DIFF1-20.0268293;
DIFF4=dif4(x);
DIFFxc_4=dif4(x_c);                   
DIFF4_c=DIFF4-75.4263;               
DIFFxc_4c=dif4(x_c)-75.4263;    

SYMBOL1 v=dot cv=black i=line ci=black;
SYMBOL2 v=circle cv=black i=spline ci=black;
SYMBOL3 v=none cv=black i= spline ci=black;

PROC PRINT;
RUN;

PROC MEANS MEAN VAR STD MIN MAX N; 
RUN;

PROC GPLOT DATA=analy;
PLOT x*date=1/VREF=1141.87 grid frame vaxis=600 to 1600 by 100 
haxis='01jan58'd to '01apr68'd by quarter;
RUN;

PROC ARIMA;
IDENTIFY VAR=x NLAG=36;
RUN;

PROC GPLOT DATA=analy;
PLOT DIFF1*date=1/VREF=20.02 grid frame vaxis=-500 to 500 by 50 
haxis='01jan58'd to '01apr68'd by quarter;
RUN;

PROC ARIMA;
IDENTIFY VAR=DIFF1 NLAG=36;
RUN;

PROC GPLOT DATA=analy;
PLOT DIFF4*date=1/VREF=75.4263 grid frame vaxis=-500 to 500 by 50 
haxis='01jan58'd to '01apr68'd by quarter;
RUN;

PROC ARIMA DATA=analy;
IDENTIFY VAR=x_c(0,4) NLAG=36;
ESTIMATE P=(0)(0)Q=(1)(4) METHOD=ml;            /* ARIMA(0,0,1)(0,1,1)_4 */
FORECAST LEAD=5 OUT=out1;   
RUN;

PROC ARIMA DATA=analy;
IDENTIFY VAR=x_c(0,4) NLAG=36;
ESTIMATE P=(0)(0) Q=(1,2)(4) METHOD=ml;         /* ARIMA(0,0,2)(0,1,1)_4 */
FORECAST LEAD=5 OUT=out2;
RUN;

DATA FINAL;
SET out2;
x=x_c+1141.87;
FORE_new=FORECAST+1141.87;
L95_new=L95+1141.87;
U95_new=U95+1141.87;
RUN;

PROC PRINT DATA=final; 
RUN;