DATA analy;
INFILE 'G:\BOX-ANN\EXPORTS.dat';
INPUT q exports @@;
t=_N_;
DATE=INTNX('quarter','1jan58'd,_N_-1); 
format date yyq5.;

exports_c=exports-1141.87;      /* _c means centered  */

SYMBOL1 v=dot cv=black i=line ci=black;
SYMBOL2 v=circle cv=black i=spline ci=black;
SYMBOL3 v=none cv=black i= spline ci=black;

PROC PRINT;
RUN;

PROC MEANS MEAN VAR STD MIN MAX N; 
RUN;

PROC GPLOT DATA=analy;
PLOT exports*date=1/VREF=1141.87 grid frame vaxis=600 to 1600 by 100 
haxis='01jan58'd to '03apr68'd by quarter;
RUN;

PROC ARIMA;
IDENTIFY VAR=exports NLAG=36;
RUN;

DATA forecast;
INFILE 'F:\pred.dat';
INPUT q predect @@;
t=_N_;
t=t+42;
DATE=INTNX('quarter','3jul68'd,_N_-1); 
format date yyq5.;
RUN;

DATA new;
SET analy forecast; By t;
RUN;

PROC PRINT;
RUN;

PROC SORT DATA=new OUT=new2; BY t;
RUN;

PROC GPLOT DATA=new2;
PLOT exports*date=1 predect*date=2/overlay VREF=1141.87 HREF='42' 
grid frame vaxis=600 to 1700 by 100 
haxis='01jan58'd to '03apr69'd by quarter;
RUN;

