DATA DATA1;                                       
INFILE 'G:\BOX-ANN\passenger3.dat';        
INPUT t1 d1 $ x1 t2 d2 $ x12 t3 d3 $ x13 @@;
t=_N_;
IF t>132 THEN DELETE;
x1=log(x1); x12=log(x12); x13=log(x13); 

x1=(x1-4.6443)/(6.32614-4.6443); x12=(x12-4.7361)/(6.4329-4.7361);
x13=(x13-4.7361)/(6.4329-4.7361); 

y=x13;            /* target value */

k=1;          
eta=7.05;         /* eta=0.01 0.05; eta=1.05; */

/* numbers of input values 144=132+12 */
    /* UNIFORM RANDOM NUMBERS for weights and biases 115 */
IF UNIFORM(1+k)<=0.5 THEN w1_11=-UNIFORM(1+k)/10; ELSE w1_11=UNIFORM(1+k)/10;
IF UNIFORM(2+k)<=0.5 THEN w1_21=-UNIFORM(2+k)/10; ELSE w1_21=UNIFORM(2+k)/10;

/* I: first linear transformation */
z1=w1_11*x1+w1_21*x12;    
    
    /* two random biases */
IF UNIFORM(5+k)<=0.5 THEN b1=-UNIFORM(5+k)/10; ELSE b1=UNIFORM(5+k)/10;

/* first 2 activity functions */
s1=1/(1+exp(-(z1+b1))); 

/* I: second linear transformation */
/* UNIFORM RANDOM NUMBERS for 2 weights */
IF UNIFORM(7+k)<=0.5 THEN w2_11=-UNIFORM(7+k)/10; ELSE w2_11=UNIFORM(7+k)/10;

z2=w2_11*s1;

/* second 1 activity function */
IF UNIFORM(9+k)<=0.5 THEN b2=-UNIFORM(9+k)/10; ELSE b2=UNIFORM(9+k)/10;
s2=1/(1+exp(-(z2+b2))); 

y_hat=s2;
By_hat=y_hat*(6.4329-4.6443)+4.6443;  

/* 1. BACKPROPAGATION step 1(right hand size) pp.12-13 */
pLpw2_11=-2*(y-y_hat)*s2*(1-s2)*s1;  

pLpb2=-2*(y-y_hat)*(s2*(1-s2))*1;      

/* 2. new wights ws_11 etc  */
w2_11=w2_11-eta*pLpw2_11;    

b2=b2-eta*pLpb2;                     

/* 2. BACKPROPAGATION step 2(left hand size) */

pLpw1_11=-2*(y-y_hat)*(w2_11*s2*(1-s2))*(x1*s1*(1-s1));  
pLpw1_21=-2*(y-y_hat)*(w2_11*s2*(1-s2))*(x12*s1*(1-s1));  

pLpb1=-2*(y-y_hat)*(w2_11*s2*(1-s2))*(1*s1*(1-s1));  

/* SECOND STEP for UPDATED WEIGHTS */
w1_11=w1_11-eta*pLpw1_11;       
w1_21=w1_21-eta*pLpw1_21;     

/* UPDATE biases for BACKPROPAGATION step 2 */
b1=b1-eta*pLpb1;                                     

/* new values of z1 */
z1=w1_11*x1+w1_21*x12;      

s1=1/(1+exp(-(z1+b1)));                            

z2=w2_11*s1;
s2=1/(1+exp(-(z2+b2)));  

y1_hat=s2;       /* The 1st trained ESTIMATEE */
By1_hat=y1_hat*(6.4329-4.7361)+4.7361;  

/* BACKPROPAGATION step 1(right hand size) */
/* PARTIAL DERIVATIVES OF LOSS FUNCTION L w/t WEIGHTS w2_11,w2_21,w2_31,w2_41 */

pLpw2_11=-2*(y-y1_hat)*(s2*(1-s2))*s1;   

pLpb2=-2*(y-y1_hat)*(s2*(1-s2))*1;

/* new weights w2s_11 of w2_11 etc p.19 */
w2_11=w2_11-eta*pLpw2_11;

b2=b2-eta*pLpb2; 

/* BACKPROPAGATION step 2(left hand size) */
/* partial derivatives */
pLpw1_11=-2*(y-y1_hat)*(w2_11*s2*(1-s2))*(x1*s1*(1-s1)); 
pLpw1_21=-2*(y-y1_hat)*(w2_11*s2*(1-s2))*(x12*s1*(1-s1));

pLpb1=-2*(y-y1_hat)*(w2_11*s2*(1-s2))*(1*s1*(1-s1));  

/* SECOND STEP for UPDATED WEIGHTS */
w1_11=w1_11-eta*pLpw1_11; 
w1_21=w1_21-eta*pLpw1_21;  

b1=b1-eta*pLpb1; 
                                                         
/* new values of z1 */
z1=w1_11*x1+w1_21*x12; 

/* UPDATE biases for BACKPROPAGATION step 2 */
s1=1/(1+exp(-(z1+b1)));                           

z2=w2_11*s1;   
s2=1/(1+exp(-(z2+b2)));                              

y2_hat=s2;               /* The 2nd ESTIMATE */
By2_hat=y2_hat*(6.4329-4.7361)+4.7361;  

             /*  This part is useful for 
             x=1; 
             DO WHILE(x<=1);  
             */

/*x_n=131996; x_n1=128; x_n2=160; x_n100=13196; x_n1000=131996; */
/* MASE_aa1=0.1128703; MASE_aa2=0.079049;
MASE_aa100=0.0020330; MASE_aa1000=0.000203248; */

/* BACKPROPAGATION step 1(right hand size) */
/* PARTIAL DERIVATIVES OF LOSS FUNCTION L w/t WEIGHTS w2_11 ets */

pLpw2_11=-2*(y-y2_hat)*(s2*(1-s2))*s1;   

pLpb2=-2*(y-y2_hat)*(s2*(1-s2))*1;

/* new weights w2s_11 of w2_11 etc p.19 */
w2_11=w2_11-eta*pLpw2_11;

b2=b2-eta*pLpb2;

/* BACKPROPAGATION step 2(left hand size) */
/* partial derivatives */
pLpw1_11=-2*(y-y2_hat)*(w2_11*s2*(1-s2))*(x1*s1*(1-s1)); 
pLpw1_21=-2*(y-y2_hat)*(w2_11*s2*(1-s2))*(x12*s1*(1-s1)); 

pLpb_1=-2*(y-y2_hat)*(w2_11*s2*(1-s2))*(1*s1*(1-s1));  

/* SECOND STEP for UPDATED WEIGHTS */
w1_11=w1_11-eta*pLpw1_11; 
w1_21=w1_21-eta*pLpw1_21;  

b1=b1-eta*pLpb1; 
                                                        
/* new values of z1, z2 */
z1=w1_11*x1+w1_21*x12; 

/* UPDATE biases for BACKPROPAGATION step 2 */
s1=1/(1+exp(-(z1+b1)));                             

z2=w2_11*s1;   
s2=1/(1+exp(-(z2+b2)));                            

y3_hat=s2;                               /* The 3rd ESTIMATE */
By3_hat=y3_hat*(6.4329-4.7361)+4.7361;   

           /*
             OUTPUT;
             x+1;
             END; 
             RUN;  */

PROC PRINT; VAR y y_hat y1_hat y2_hat y3_hat;
RUN; 


DATA NEW1;
SET DATA1;

MSE=(y-y_hat)**2;  
MSE1=(y-y1_hat)**2;                     
MSE2=(y-y2_hat)**2; 
MSE3=(y-y3_hat)**2;

MAE=ABS(y-y_hat);
MAE1=ABS(y-y1_hat);
MAE2=ABS(y-y2_hat);
MAE3=ABS(y-y3_hat);

                   /* y4=lag4(y); */

RMSE=SQRT(MSE);
RMSE1=SQRT(MSE1);
RMSE2=SQRT(MSE2);
RMSE3=SQRT(MSE3);

/*
IF y=0 THEN y=0.001;
MPE=((y-y_hat)/y)*100;
MPE1=((y-y1_hat)/y)*100;
MPE2=((y-y2_hat)/y)*100; 
MPE3=((y-y3_hat)/y)*100; 

MAPE=(ABS((y-y_hat)/y))*100;
MAPE1=(ABS((y-y1_hat)/y))*100;
MAPE2=(ABS((y-y2_hat)/y))*100;
MAPE3=(ABS((y-y3_hat)/y))*100;

MASE_dena=(abs(y-lag4(y)));  */


/*
MEAN(abs(y-lag4(y)));
proc sort data=new2; by x;
run;
proc print data=new2; var y y1_hat y2_hat;
run; 
PROC PRINT; VAR MASE_dena;
RUN;*/

PROC MEANS DATA=NEW1; VAR MSE MSE1 MSE2 MSE3;
RUN;

PROC MEANS DATA=NEW1; VAR MAE MAE1 MAE2 MAE3;
RUN; 

/* 
PROC MEANS DATA=NEW1; VAR MASE_dena;
RUN;

PROC MEANS DATA=NEW1; VAR MPE MPE1 MPE2 MPE3;
RUN; 

PROC MEANS DATA=NEW1; VAR MAPE MAPE1 MAPE2 MAPE3;
RUN;

PROC MEANS DATA=NEW1; VAR MASE_dena;    
RUN; 
*/

DATA NEW2;
SET DATA1 NEW1;

/* MASE_dena=0.000214245; by hand */

/* IF MASE_dena=0 THEN MASE_dena=0.00001; */


/*
MASE=MAE/MASE_dena;
MASE1=MAE1/MASE_dena;    
MASE2=MAE2/MASE_dena;     
MASE3=MAE3/MASE_dena; 
 
PROC MEANS; VAR MASE MASE1 MASE2 MASE3;
RUN; */

SYMBOL1 v=dot cv=black l=1 i=line color=red;
SYMBOL2 v=circle cv=black i=line ci=black; 
SYMBOL3 v=star cv=black i=line ci=black; 
SYMBOL4 v=point cv=black i=line ci=black; 
SYMBOL5 v=none cv=black i=line ci=black; 
SYMBOL6 v=none cv=black i=spline ci=black;

PROC GPLOT DATA=DATA1;   
PLOT y*t=1 y1_hat*t=3 /OVERLAY legend GRID FRAME; 
/* VREF=0.5 HREF=132 VAXIS=0.2 TO 0.8 BY 0.1 HAXIS=0 TO 140 BY 10; */
RUN;

PROC GPLOT DATA=DATA1;    
PLOT y*t=1 y2_hat*t=3 /OVERLAY legend GRID FRAME; 
/* VREF=0.5 HREF=132 VAXIS=0.2 TO 0.8 BY 0.1 HAXIS=0 TO 140 BY 10; */
RUN;

PROC GPLOT DATA=DATA1;    
PLOT y*t=1 y3_hat*t=3 /OVERLAY legend GRID FRAME; 
/* VREF=0.5 HREF=132 VAXIS=0.2 TO 0.8 BY 0.1 HAXIS=0 TO 140 BY 10; */
RUN;


PROC GPLOT DATA=DATA1;    
PLOT y*t=1 y4_hat*t=3 /OVERLAY legend GRID FRAME; 
/* VREF=0.5 HREF=132 VAXIS=0.2 TO 0.8 BY 0.1 HAXIS=0 TO 140 BY 10; */
RUN;


PROC GPLOT DATA=DATA1;    
PLOT y*t=1 y5_hat*t=3 /OVERLAY legend GRID FRAME; 
/* VREF=0.5 HREF=132 
VAXIS=0.2 TO 0.8 BY 0.1 HAXIS=0 TO 140 BY 10; */
RUN;

PROC GPLOT DATA=DATA1;    
PLOT y*t=1 y1_hat*t=2 y2_hat*t=3 y3_hat*t=4 y4_hat*t=5 y5_hat*t=6/OVERLAY legend GRID FRAME; 
/* VREF=0.5 HREF=132 VAXIS=0.2 TO 0.8 BY 0.1 HAXIS=0 TO 140 BY 10; */
RUN;

PROC GPLOT DATA=NEW1;   
PLOT oy*t=1 oy2_hat*t=2 /OVERLAY legend GRID FRAME; 
/* VREF=0.5 HREF=132 VAXIS=0.2 TO 0.8 BY 0.1 HAXIS=0 TO 140 BY 10; */
RUN;

PROC GPLOT DATA=NEW1;    
PLOT oy*t=1 oy3_hat*t=2 /OVERLAY legend GRID FRAME; 
/* VREF=0.5 HREF=132 VAXIS=0.2 TO 0.8 BY 0.1 HAXIS=0 TO 140 BY 10; */
RUN;

PROC GPLOT DATA=NEW1;    
PLOT oy*t=1 oy4_hat*t=2 /OVERLAY legend GRID FRAME; 
/* VREF=0.5 HREF=132 VAXIS=0.2 TO 0.8 BY 0.1 HAXIS=0 TO 140 BY 10; */
RUN;

PROC GPLOT DATA=NEW1;     
PLOT oy*t=1 oy5_hat*t=2 /OVERLAY legend GRID FRAME; 
/* VREF=0.5 HREF=132 VAXIS=0.2 TO 0.8 BY 0.1 HAXIS=0 TO 140 BY 10; */
RUN;
PROC GPLOT DATA=NEW1;     
PLOT oy*t=1 oy1_hat*t=2 oy2_hat*t=3 oy3_hat*t=4 oy4_hat*t=5 oy5_hat*t=2/OVERLAY legend GRID FRAME; 
/* VREF=0.5 HREF=132 VAXIS=0.2 TO 0.8 BY 0.1 HAXIS=0 TO 140 BY 10; */
RUN;

PROC GPLOT DATA=NEW1;    
PLOT oy*t=1/OVERLAY legend GRID FRAME; 
/* VREF=0.5 HREF=132 VAXIS=0.2 TO 0.8 BY 0.1 HAXIS=0 TO 140 BY 10; */
RUN;






