DATA DATA1; /* for forecasting */ 
INFILE 'G:\BOX-ANN\passenger3-1.dat'; 
/* INFILE 'F:\FSAScodedata_2010\passenger3-1.dat'; */        /* ok */
INPUT t1 d1 $ x1 t2 d2 $ x12 t3 d3 $ x13 @@;
t=_N_;
IF t>145 THEN DELETE; /* IF t>132 THEN DELETE; */

x1=log(x1); x12=log(x12); x13=log(x13);  /* FOR CONSTANT VARIANCE */
 
x1 =(x1-4.6443)/(6.3261-4.6443);         /* ON [0,1] */
x12=(x12-4.7361)/(6.4329-4.7361);
x13=(x13-4.7361)/(6.4329-4.7361);

y=x13;                /* target value */

eta=7.01;             /* eta=17; */ 
k=1;
/* numbers of input values 144=132+12 */
/* UNIFORM RANDOM NUMBERS for weights and biases 115 */
IF UNIFORM(1+k)<=0.5 THEN w1_11=-UNIFORM(1+k)/10; ELSE w1_11=UNIFORM(1+k)/10;
IF UNIFORM(2+k)<=0.5 THEN w1_21=-UNIFORM(2+k)/10; ELSE w1_21=UNIFORM(2+k)/10;
IF UNIFORM(3+k)<=0.5 THEN w1_12=-UNIFORM(3+k)/10; ELSE w1_12=UNIFORM(3+k)/10;
IF UNIFORM(4+k)<=0.5 THEN w1_22=-UNIFORM(4+k)/10; ELSE w1_22=UNIFORM(4+k)/10;
    /* I: first linear transformation */
z1=w1_11*x1+w1_21*x12;    
z2=w1_12*x1+w1_22*x12;    
    /* two random biases */
IF UNIFORM(5+k)<=0.5 THEN b1=-UNIFORM(5+k)/10; ELSE b1=UNIFORM(5+k)/10;
IF UNIFORM(6+k)<=0.5 THEN b2=-UNIFORM(6+k)/10; ELSE b2=UNIFORM(6+k)/10;
    /* first 2 activity functions */
s1=1/(1+exp(-(z1+b1))); 
s2=1/(1+exp(-(z2+b2)));

/* I: second linear transformation */
/* UNIFORM RANDOM NUMBERS for 2 weights */

IF UNIFORM(7+k)<=0.5 THEN w2_11=-UNIFORM(7+k)/10; ELSE w2_11=UNIFORM(7+k)/10;
IF UNIFORM(8+k)<=0.5 THEN w2_21=-UNIFORM(8+k)/10; ELSE w2_21=UNIFORM(8+k)/10; 

z3=w2_11*s1+w2_21*s2;

/* second 1 activity function */
IF UNIFORM(9+k)<=0.5 THEN b3=-UNIFORM(9+k)/10; ELSE b3=UNIFORM(9+k)/10;

s3=1/(1+exp(-(z3+b3))); 
y1_hat=s3;
                        
/* 1. BACKPROPAGATION step 1(right hand size) */  /* no more random numbers */
/* for 1st BACKPROPAGATION */
pLpw2_11=-2*(y-y1_hat)*s3*(1-s3)*s1;  
pLpw2_21=-2*(y-y1_hat)*s3*(1-s3)*s2;   

pLpb3=-2*(y-y1_hat)*(s3*(1-s3))*1;      

/* 2. new wights ws_11 etc pp13-14 first line */
w2_11=w2_11-eta*pLpw2_11;    
w2_21=w2_21-eta*pLpw2_21;   

b3=b3-eta*pLpb3;                     
     
/* 2. BACKPROPAGATION step 2(left hand size) */

pLpw1_11=-2*(y-y1_hat)*(w2_11*s3*(1-s3))*(x1*s1*(1-s1));  
pLpw1_21=-2*(y-y1_hat)*(w2_11*s3*(1-s3))*(x12*s1*(1-s1));  
pLpw1_12=-2*(y-y1_hat)*(w2_21*s3*(1-s3))*(x1*s2*(1-s2)); 
pLpw1_22=-2*(y-y1_hat)*(w2_21*s3*(1-s3))*(x12*s2*(1-s2));

pLpb1=-2*(y-y1_hat)*(w2_11*s3*(1-s3))*(1*s1*(1-s1));  
pLpb2=-2*(y-y1_hat)*(w2_21*s3*(1-s3))*(1*s2*(1-s2));

/* SECOND STEP for UPDATED WEIGHTS */

w1_11=w1_11-eta*pLpw1_11;       
w1_21=w1_21-eta*pLpw1_21;     
w1_12=w1_12-eta*pLpw1_12; 
w1_22=w1_22-eta*pLpw1_22;

/* UPDATE biases for BACKPROPAGATION step 2 */
b1=b1-eta*pLpb1;                                     
b2=b2-eta*pLpb2; 

/* new values of z1, z2 */
z1=w1_11*x1+w1_21*x12;   
z2=w1_12*x1+w1_22*x12;

s1=1/(1+exp(-(z1+b1)));   
s2=1/(1+exp(-(z2+b2)));  

z3=w2_11*s1+w2_21*s2;
s3=1/(1+exp(-(z3+b3)));              
y2_hat=s3;               /* The 2nd trained ESTIMATEE */

/* 1. BACKPROPAGATION step 1(right hand size) */

pLpw2_11=-2*(y-y2_hat)*(s3*(1-s3))*s1;   
pLpw2_21=-2*(y-y2_hat)*(s3*(1-s3))*s2;  

pLpb3=-2*(y-y2_hat)*(s3*(1-s3))*1;

/* 2. new wights ws_11 etc pp13-14 first line */

w2_11=w2_11-eta*pLpw2_11;
w2_21=w2_21-eta*pLpw2_21;

b3=b3-eta*pLpb3; 

/* 2. BACKPROPAGATION step 2(left hand size) pp.14-15 */
pLpw1_11=-2*(y-y2_hat)*(w2_11*s3*(1-s3))*(x1*s1*(1-s1)); 
pLpw1_21=-2*(y-y2_hat)*(w2_11*s3*(1-s3))*(x12*s1*(1-s1));
pLpw1_12=-2*(y-y2_hat)*(w2_21*s3*(1-s3))*(x1*s2*(1-s2));
pLpw1_22=-2*(y-y2_hat)*(w2_21*s3*(1-s3))*(x12*s2*(1-s2)); 

pLpb1=-2*(y-y2_hat)*(w2_11*s3*(1-s3))*(1*s1*(1-s1));  
pLpb2=-2*(y-y2_hat)*(w2_21*s3*(1-s3))*(1*s2*(1-s2));

w1_11=w1_11-eta*pLpw1_11;       
w1_21=w1_21-eta*pLpw1_21;     
w1_12=w1_12-eta*pLpw1_12;
w1_22=w1_22-eta*pLpw1_22;

b1=b1-eta*pLpb1; 
b2=b2-eta*pLpb2; 

/* new values of z1, z2 */
z1=w1_11*x1+w1_21*x12; 
z2=w1_12*x1+w1_22*x12;

/* UPDATED biases for BACKPROPAGATION step 2 */
s1=1/(1+exp(-(z1+b1)));                           
s2=1/(1+exp(-(z2+b2)));

z3=w2_11*s1+w2_21*s2;   
s3=1/(1+exp(-(z3+b3)));                              
           
y3_hat=s3;                  
                  
/* 2. BACKPROPAGATION step 2(left hand size) pp.14-15 */

pLpw1_11=-2*(y-y3_hat)*(w2_11*s3*(1-s3))*(x1*s1*(1-s1)); 
pLpw1_21=-2*(y-y3_hat)*(w2_11*s3*(1-s3))*(x12*s1*(1-s1));
pLpw1_12=-2*(y-y3_hat)*(w2_21*s3*(1-s3))*(x1*s2*(1-s2));
pLpw1_22=-2*(y-y3_hat)*(w2_21*s3*(1-s3))*(x12*s2*(1-s2)); 

pLpb1=-2*(y-y3_hat)*(w2_11*s3*(1-s3))*(1*s1*(1-s1));  
pLpb2=-2*(y-y3_hat)*(w2_21*s3*(1-s3))*(1*s2*(1-s2));

w1_11=w1_11-eta*pLpw1_11;       
w1_21=w1_21-eta*pLpw1_21;     
w1_12=w1_12-eta*pLpw1_12;
w1_22=w1_22-eta*pLpw1_22;

b1=b1-eta*pLpb1; 
b2=b2-eta*pLpb2; 

/* new values of z1, z2 */
z1=w1_11*x1+w1_21*x12; 
z2=w1_12*x1+w1_22*x12;

/* UPDATE biases for BACKPROPAGATION step 2 */
s1=1/(1+exp(-(z1+b1)));                           
s2=1/(1+exp(-(z2+b2)));

z3=w2_11*s1+w2_21*s2;   
s3=1/(1+exp(-(z3+b3)));                              
           
y4_hat=s3;                  
        
PROC PRINT; VAR t y y1_hat y2_hat y3_hat y4_hat; 
RUN; 
PROC MEANS; VAR y y1_hat y2_hat y3_hat y4_hat;
RUN; 
        
DATA NEW1;      /* for MSE, MAE, RMSE, MAPE */ 
SET DATA1;

MSE1=(y-y1_hat)**2;                     
MSE2=(y-y2_hat)**2; 
MSE3=(y-y3_hat)**2;
MSE4=(y-y4_hat)**2;  

MAE1=ABS(y-y1_hat);
MAE2=ABS(y-y2_hat);
MAE3=ABS(y-y3_hat);
MAE4=ABS(y-y4_hat);

y4=lag4(y);

RMSE1=SQRT(MSE1);
RMSE2=SQRT(MSE2);
RMSE3=SQRT(MSE3);
RMSE4=SQRT(MSE4);

IF y=0 THEN y=0.001;

MPE1=((y-y1_hat)/y)*100;
MPE2=((y-y2_hat)/y)*100; 
MPE3=((y-y3_hat)/y)*100; 
MPE4=((y-y4_hat)/y)*100;

MAPE1=(ABS((y-y1_hat)/y))*100;
MAPE2=(ABS((y-y2_hat)/y))*100;
MAPE3=(ABS((y-y3_hat)/y))*100;
MAPE4=(ABS((y-y4_hat)/y))*100;

MASE_dena=(abs(y-lag4(y)));

/*
MEAN(abs(y-lag4(y)));
proc sort data=new2; by x;
run;
proc print data=new2; var y y1_hat y2_hat;
run; 
PROC PRINT; VAR MASE_dena;
RUN;*/

y=y*(6.4329-4.7361)+4.7361;
y1_hat=y1_hat*(6.4329-4.7361)+4.7361;
y2_hat=y2_hat*(6.4329-4.7361)+4.7361;
y3_hat=y3_hat*(6.4329-4.7361)+4.7361;
y4_hat=y4_hat*(6.4329-4.7361)+4.7361;

oy=exp(y); 
oy1_hat=exp(y1_hat);
oy2_hat=exp(y2_hat);
oy3_hat=exp(y3_hat);
oy4_hat=exp(y4_hat);

diff1=y1_hat-y;
diff2=y2_hat-y;
diff4=y4_hat-y;
diff22=oy2_hat-oy;
diff44=oy4_hat-oy;

oMSE4=(oy-oy4_hat)**2;  
oMAE4=ABS(oy-oy4_hat);
oRMSE4=SQRT(oMSE4);
oMPE4=((oy-oy4_hat)/oy)*100;
oMAPE4=(ABS((oy-oy4_hat)/oy))*100;

e=y-y4_hat;   
if t<=120 then delete;     /* if t<=120 then delete; */

PROC PRINT; VAR MASE_dena;
RUN;

PROC PRINT; VAR t oy oy1_hat oy2_hat oy3_hat oy4_hat;
RUN;

PROC MEANS DATA=NEW1; VAR MSE1 MSE2 MSE3 MSE4 MASE_dena;
RUN;

PROC MEANS DATA=NEW1; VAR MAE1 MAE2 MAE3 MAE4;
RUN; 
 
PROC MEANS DATA=NEW1; VAR MASE_dena;
RUN;

PROC MEANS DATA=NEW1; VAR MPE1 MPE2 MPE3 MPE4;
RUN; 

PROC MEANS DATA=NEW1; VAR MAPE1 MAPE2 MAPE3 MAPE4;
RUN;

PROC MEANS DATA=NEW1; VAR MASE_dena;    
RUN; 

PROC MEANS DATA=NEW1; VAR e;    
RUN; 

PROC MEANS DATA=NEW1; VAR oMSE4 oMAE4 oRMSE4 oMPE4 oMAPE4; /* key */
RUN;

SYMBOL1 v=dot cv=black l=1 i=line color=red;
SYMBOL2 v=circle cv=black i=line ci=black; 
SYMBOL3 v=star cv=black i=line ci=black; 
SYMBOL4 v=point cv=black i=line ci=black; 
SYMBOL5 v=none cv=black i=line ci=black; 
SYMBOL6 v=none cv=black i=spline ci=black;

PROC GPLOT DATA=NEW1;  
PLOT oy*t=1 /* y1_hat*t=2 y2_hat*t=3 y3_hat*t=2 */ oy4_hat*t=2 /OVERLAY legend GRID FRAME; 
/* VREF=0.5 HREF=120.5 VAXIS=0.0 TO 1.1 BY 0.1 HAXIS=0 TO 140 BY 10; */ 
RUN;

DATA NEW2;
SET DATA1 NEW1;
/* if t=133 then x1=0.80346; */

/* MASE_dena=0.000214245; */                /* by hand */

/* IF MASE_dena=0 THEN MASE_dena=0.00001; */

MASE1=MAE1/MASE_dena;    
MASE2=MAE2/MASE_dena;     
MASE3=MAE3/MASE_dena; 
MASE4=MAE4/MASE_dena; 
 
PROC MEANS; VAR MASE1 MASE2 MASE3 MASE4;
RUN;

SYMBOL1 v=dot cv=black l=1 i=line color=red;
SYMBOL2 v=circle cv=black i=line ci=black; 
SYMBOL3 v=star cv=black i=line ci=black; 
SYMBOL4 v=point cv=black i=line ci=black; 
SYMBOL5 v=none cv=black i=line ci=black; 
SYMBOL6 v=none cv=black i=spline ci=black;

PROC GPLOT DATA=DATA1;   
PLOT y*t=1 /* y1_hat*t=2 y2_hat*t=3 y3_hat*t=2 */ y4_hat*t=2 /OVERLAY legend GRID FRAME 
VREF=0.5 HREF=120.5 VAXIS=0.0 TO 1.1 BY 0.1 HAXIS=0 TO 140 BY 10; 
RUN;

PROC GPLOT DATA=DATA1;   
PLOT y*t=2 /* y1_hat*t=5 y2_hat*t=3 y3_hat*t=4 */ y4_hat*t=1 /OVERLAY legend GRID FRAME 
VREF=0.8 HREF=120.5 VAXIS=0.5 TO 1.1 BY 0.1 HAXIS=121 TO 133 BY 1.0; 
RUN;

PROC GPLOT DATA=NEW2;  
PLOT oy*t=1 /* y1_hat*t=2 y2_hat*t=3 y3_hat*t=2 */ oy4_hat*t=2 /OVERLAY legend GRID FRAME
HREF=120.5; 
/* VREF=0.5 HREF=120.5 VAXIS=0.0 TO 1.1 BY 0.1 HAXIS=0 TO 140 BY 10; */ 
RUN;

PROC GPLOT DATA=NEW2;   
PLOT oy*t=2 /* y1_hat*t=5 y2_hat*t=3 y3_hat*t=4 */ oy4_hat*t=1 /OVERLAY legend GRID FRAME
HREF=120.5; 
/* VREF=0.8 HREF=120.5 VAXIS=0.5 TO 1.1 BY 0.1 HAXIS=121 TO 133 BY 1.0; */ 
RUN;

DATA DATA2;
INFILE 'F:\NSAScodedata\passenger3-4.dat'; 
INPUT t dat $ oy oy4_hat hw @@;

oMSE4=(oy-oy4_hat)**2;  
oMAE4=ABS(oy-oy4_hat);
oRMSE4=SQRT(oMSE4);
oMPE4=((oy-oy4_hat)/oy)*100;
oMAPE4=(ABS((oy-oy4_hat)/oy))*100;

oMSEhw=(oy-hw)**2;  
oMAEhw=ABS(oy-hw);
oRMSEhw=SQRT(oMSEhw);
oMPEhw=((oy-hw)/oy)*100;
oMAPEhw=(ABS((oy-hw)/oy))*100;

PROC MEANS DATA=DATA2; VAR oMSE4 oMAE4 oRMSE4 oMPE4 oMAPE4; /* key */
RUN;
PROC MEANS DATA=DATA2; VAR oMSEhw oMAEhw oRMSEhw oMPEhw oMAPEhw; 
RUN;

PROC GPLOT DATA=DATA2;   
PLOT oy*t=2 oy4_hat*t=1 hw*t=3/OVERLAY legend GRID FRAME HREF=120.5; 
/* VREF=0.8 HREF=120.5 VAXIS=0.5 TO 1.1 BY 0.1 HAXIS=121 TO 133 BY 1.0; */ 
RUN;

DATA DATA3;
SET DATA1 DATA2;

PROC GPLOT DATA=DATA2;   
PLOT oy*t=2 oy4_hat*t=1 hw*t=3/OVERLAY legend GRID FRAME HREF=120.5; 
/* VREF=0.8 HREF=120.5 VAXIS=0.5 TO 1.1 BY 0.1 HAXIS=121 TO 133 BY 1.0; */ 
RUN;

PROC GPLOT DATA=DATA2;   
PLOT oy*t=2 oy4_hat*t=1 hw*t=3/OVERLAY legend GRID FRAME HREF=120.5 
HAXIS=121 TO 133 BY 1.0; 
RUN;

DATA DATA3;
INPUT t predHW SE L95 R95 @@;
x1=log(x1); x12=log(x12); x13=log(x13);  /* CONSTANT VARIANCE */
 
x1 =(x1-4.6443)/(6.3261-4.6443);         /* ON [0,1] */
x12=(x12-4.7361)/(6.4329-4.7361);
x13=(x13-4.7361)/(6.4329-4.7361);

CARDS;
121 . 415.660  .    .             
122 . 407.090  .    .             
123 . 457.641  .    .             
124 . 448.620  .    .             
125 . 459.883  .    .             
126 . 509.715  .    .             
127 . 555.722  .    .             
128 . 555.849  .    .             
129 . 489.836  .    .             
130 . 446.802  .    .             
131 . 411.257  .    .             
132 . 445.825  .    .             
133 6.0387 0.0367 5.9668 6.1106   
134 5.9888 0.0438 5.9030 6.0747   
135 6.1456 0.0499 6.0478 6.2433   
136 6.1192 0.0553 6.0107 6.2276   
137 6.1599 0.0603 6.0417 6.2700   
138 6.3049 0.0638 6.1778 6.4320   
139 6.4336 0.0691 6.2981 6.5690   
140 6.4463 0.0731 6.3030 6.5896   
141 6.2671 0.0769 6.1163 6.4178   
142 6.1366 0.0806 5.9787 6.2945   
143 6.0083 0.0840 5.8436 6.1730   
144 6.1148 0.0874 5.9435 6.2860   
;

PROC GPLOT DATA=DATA3;   
PLOT predHW*t=2 L95*t=1 R95*t=3/OVERLAY legend GRID FRAME HREF=132.5 
HAXIS=133 TO 144 BY 1.0; 
RUN;

/*
VREF=0.5 HREF=120.5 VAXIS=0.0 TO 1.1 BY 0.1

oMSE4=(oy-oy4_hat)**2;  
oMAE4=ABS(oy-oy4_hat);
oRMSE4=SQRT(oMSE4);
oMPE4=((oy-oy4_hat)/oy)*100;
oMAPE4=(ABS((oy-oy4_hat)/oy))*100;
*/

/*       NNAR
121 JAN 432.951  132 DEC 405    133 JAN 417  0 
122 FEB 399.315  133 JAN 417    134 FEB 391  0    
123 MAR 430.070  134 FEB 391    135 MAR 419  0    
124 APR 475.357  135 MAR 419    136 APR 461  0    
125 MAY 492.694  136 APR 461    137 MAY 472  0    
126 JUN 539.227  137 MAY 472    138 JUN 535  0    
127 JUL 583.821  138 JUN 535    139 JUL 622  0    
128 AUG 575.229  139 JUL 622    140 AUG 606  0    
129 SEP 527.281  140 AUG 606    141 SEP 508  0    
130 OCT 475.550  141 SEP 508    142 OCT 461  0    
131 NOV 395.909  142 OCT 461    143 NOV 390  0    
132 DEC 445.595  143 NOV 390    144 DEC 432  0    

  HW
415.660 
407.090
457.641
448.620
459.883
509.715
555.722
555.849
489.836
446.802
411.257 
445.825

        ORI OY4(ANN)  hw
121 JAN 360 432.951  415.660
122 FEB 342 399.315  407.090
123 MAR 406 430.070  457.641
124 APR 396 475.357  448.620
125 MAY 420 492.694  459.883
126 JUN 472 539.227  509.715
127 JUL 548 583.821  555.722
128 AUG 559 575.229  555.849
129 SEP 463 527.281  489.836
130 OCT 407 475.550  446.802
131 NOV 362 395.909  411.257
132 DEC 405 445.595  445.825

*/